// turLisp.cpp

#include <Windows.h>
#include <stdio.h>
#include <math.h>
#include "dialog.h"

#define GC 1 // 1:Kx[WRNVsB0:sȂB
#define USE_PRINTER 1 // v^̋@\ǉ

#define BUFLEN 4000
#define CELL_SIZE 32000000L
#define STRING_SIZE 320000L
#define NUMBER_SIZE 3200000L
#define GLOBAL_SIZE 3200L
#define FUNCTION_SIZE 3200L
#define DISPBUFLEN 30000

#define PI 3.14159265

#define CELL_STACK_SIZE 32000000L
#define NUMBER_STACK_SIZE 3200000L
#define LOC_STACK_SIZE 3200000L

#define CELL_SIZE_MIN 1000L
#define NUMBER_SIZE_MIN 1000L

#if GC

struct _afloat {
	TCHAR gc;
	float f;
};

typedef struct _afloat AFLOAT;

#endif

struct _cell {
	TCHAR attr;
	TCHAR gc;
	struct _cell *car;
	struct _cell *cdr;
};

typedef struct _cell CELL;

struct _symval {
	TCHAR *sym;
	CELL *val;
};

typedef struct _symval SYMVAL;

ATOM InitApp(HINSTANCE);
BOOL InitInstance(HINSTANCE,int);
LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);
BOOL CALLBACK DialogFunc(HWND,UINT,WPARAM,LPARAM);
void SkipTerm(TCHAR *,TCHAR *);
BOOL CheckBrace(TCHAR *);
TCHAR *SkipSpc(TCHAR *);
BOOL isKanji(TCHAR *);
CELL *getCell(void);
TCHAR *getString(TCHAR *);
CELL *readFromString(TCHAR *);
void NewString(TCHAR *,TCHAR *);
BOOL isListString(TCHAR *);
void getCarString(TCHAR *,TCHAR *);
BOOL myisdigit(TCHAR);

#if GC
AFLOAT *getNumber(float);
CELL *IncCellStack(CELL *);
int IncLocStack(SYMVAL *,long);
void gc(void);
void Disable(CELL *);
void InitCellAndNumber(void);
#else
float *getNumber(float);
#endif
void getCdrString(TCHAR *,TCHAR *);
void mystrncpy(TCHAR *,TCHAR *,int);
void forPrint(CELL *,TCHAR *);
BOOL printS(CELL *,TCHAR *);
BOOL printS2(CELL *,TCHAR *);
BOOL printS3(CELL *,TCHAR *);
void myftoa(TCHAR *,float);
float myatof(TCHAR *);
CELL *eval(CELL *,SYMVAL *,long);
CELL *evalu(CELL *,SYMVAL *,long);
void printXY(CELL *,int,int);
long getLocal(SYMVAL *,long,TCHAR *);
long getSymVal2(TCHAR *);
long getSymVal(TCHAR *);
BOOL initSymval(void);
CELL *tand(CELL *,SYMVAL *,long);
CELL *tor(CELL *,SYMVAL *,long);
CELL *times(CELL *,SYMVAL *,long);
CELL *plus(CELL *,SYMVAL *,long);
CELL *minus(CELL *,SYMVAL *,long);
CELL *divide(CELL *,SYMVAL *,long);
CELL *tprogn(CELL *,SYMVAL *,long);
CELL *minusp(CELL *);
CELL *condition(CELL *,SYMVAL *,long);
CELL *loopBody(CELL *,SYMVAL *,long);
SYMVAL *getFuncval(TCHAR *);
SYMVAL *getFuncval2(TCHAR *);
long tlength(CELL *);
BOOL initTemploc(SYMVAL *,long,CELL *,CELL *,SYMVAL *,long);
CELL *load(TCHAR *,SYMVAL *,long);
int getWChar(FILE *);
BOOL loading(FILE *,SYMVAL *,long);
BOOL GetSExp(TCHAR *,FILE *);
CELL *fd(CELL *);
CELL *lt(CELL *);
float TrueAnglePlus(float);
CELL *rt(CELL *);
float TrueAngleMinus(float);
CELL *bk(CELL *);
void XorTurtle(HDC);
CELL *setpos(CELL *,CELL *);
CELL *trandom(CELL *);
CELL *tsqrt(CELL *);
CELL *xwidth(void);
CELL *ywidth(void);
CELL *xcenter(void);
CELL *ycenter(void);
CELL *tcs(void);
CELL *setf(CELL *,CELL *,SYMVAL *,long);
CELL *MakeHashTable(void);
BOOL teql(CELL *,CELL *,BOOL);
CELL *tassoc(CELL *,CELL *,BOOL);
CELL *gethash(CELL *,CELL *,SYMVAL *,long);
CELL *remhash(CELL *,CELL *,SYMVAL *,long);
CELL *BeforeAssoc(CELL *,CELL *,BOOL,CELL *);
CELL *AfterAssoc(CELL *,CELL *,BOOL);
CELL *funcall(CELL *,CELL *,SYMVAL *,long);
CELL *apply(CELL *,CELL *,SYMVAL *,long);
BOOL MakeQuoteText(TCHAR *,int);
void slide(TCHAR *,int);
TCHAR *taiou(TCHAR *);
TCHAR *StrExist(TCHAR *);

DWORD Execute(LPVOID param);

#if USE_PRINTER
void turPrintOut(void);
BOOL DrawLineAndCicrle(HDC);
BOOL GetLineCor(CELL *,int *,int *,int *,int *);
BOOL OneArc(HDC,CELL *);
#endif

CELL *getPoint(void);
CELL *getCorner(CELL *);
void XorBox(HWND,short,short,short,short);
CELL *arc(CELL *,SYMVAL *,long);
void turWrite(void);
BOOL SaveLineAndCircle(FILE *,FILE *);
BOOL SaveOneArc(FILE *,CELL *);
BOOL GetLineCorFloat(CELL *,float *,float *,float *,float *);
void turRead(void);
CELL *getLineLc(FILE *);
CELL *getCircleLc(FILE *);
CELL *tlist(CELL *,SYMVAL *,long);

TCHAR szClassName[] = TEXT("turLisp");
TCHAR szTitle[64],szFormat[] = TEXT("turLisp ver3.15");
TCHAR MenuStr[] = TEXT("MYMENU");
TCHAR MyDbStr[] = TEXT("MYDB");
TCHAR IconStr[] = TEXT("MYICON");
HINSTANCE hInst;
HWND hwnd;
HDC memdc,ghdc;
TCHAR str[BUFLEN];
TCHAR lineStr[BUFLEN];
TCHAR TitleStr[DISPBUFLEN + 50];
int pN;
int maxX,maxY;
HBITMAP hbit;

CELL *cl;
TCHAR *strArea;

#if GC
AFLOAT *nArea;
#else
float *nArea;
#endif

SYMVAL *sv;
SYMVAL *fv;
CELL *curCl;
TCHAR *curStr;

#if GC
AFLOAT *curN;
#else
float *curN;
#endif
SYMVAL *curSv;
SYMVAL *curFv;
CELL *NILCell,*TCell;

unsigned char bom[2];

/* ^[g֘AO[oϐ */
BOOL penDown = TRUE;
float penX = 0.0;
float penY = 0.0;
float penAngle = 90.0;
int penColor = 0;
float centerX;
float centerY;
BOOL turtleShowing = TRUE;
HPEN hPen,hPenL,hPen1,hPen2,hPen3,hPen4,hPen5,hPen6,hPen7;

CELL *gtop;
DWORD Tid;
HANDLE ThreadHandle = NULL;

int KeyValue = 0;

#if GC
CELL **CellStack,**curCellStack;
//AFLOAT **NumberStack,**curNumberStack;
SYMVAL **LocStack,**curLocStack;
BOOL GetToEndCell = FALSE;
long FreeCellSize,FreeNumberSize;
#endif

#if USE_PRINTER
CELL *linesCell,*circlesCell,*filenameCell,*returnCell;
BOOL LineCircle;
float printerCenterX,printerCenterY;
#endif

short mouseX,mouseY,mouseX2,mouseY2,mouseX3,mouseY3,mouseX4,mouseY4;
BOOL mouseDown = FALSE,mouseRDown = FALSE,Corner = FALSE;

int WINAPI WinMain(HINSTANCE hCurInst,HINSTANCE hPrevInst,LPSTR lpsCmdLine,int nCmdShow)
{
	MSG msg;
	BOOL bRet;

	hInst = hCurInst;

	nCmdShow = SW_MAXIMIZE; // Add on 2013.10.18

	if (!InitApp(hCurInst)) return FALSE;
	if (!InitInstance(hCurInst,nCmdShow)) return FALSE;
	while ((bRet = GetMessage(&msg,NULL,0,0)) != 0) {
		if (bRet == -1) {
			break;
		}
		else {
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	return (int)msg.wParam;
}

ATOM InitApp(HINSTANCE hInst)
{
	WNDCLASSEX wc;

	wc.cbSize = sizeof(WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInst;
	wc.hIcon = NULL;
//	wc.hIcon = LoadIcon(hInst,IconStr);
	wc.hCursor = (HCURSOR)LoadImage(NULL,MAKEINTRESOURCE(IDC_ARROW),IMAGE_CURSOR,0,0,LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = MenuStr;
	wc.lpszClassName = szClassName;
	wc.hIconSm = NULL;
	return RegisterClassEx(&wc);
}

BOOL InitInstance(HINSTANCE hInst,int nCmdShow)
{
	HWND hWnd;

	wsprintf(szTitle,szFormat,10,3);
	hWnd = CreateWindow(szClassName,szTitle,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,hInst,NULL);
	if (!hWnd) return FALSE;
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd);
	return TRUE;
}

LRESULT CALLBACK WndProc(HWND hWnd,UINT msg,WPARAM wp,LPARAM lp)
{
	HDC hdc;
	PAINTSTRUCT ps;
	int id;
	TCHAR *e;
	CELL *top;
	HBRUSH hbrush;
	RECT rc;
	POINT pnt;
	static BOOL First = TRUE,Kill = FALSE,CornerFirst = TRUE;
	POINTS pnts;

    hwnd = hWnd;
	switch (msg) {
	    case WM_KEYDOWN:
			SuspendThread(ThreadHandle);
			KeyValue = (int)wp;
			ResumeThread(ThreadHandle);
			break;
		case WM_KEYUP:
			SuspendThread(ThreadHandle);
			KeyValue = 0;
			ResumeThread(ThreadHandle);
			break;
		case WM_LBUTTONDOWN:
			SuspendThread(ThreadHandle);
			mouseDown = TRUE;
			pnts = MAKEPOINTS(lp);
            mouseX = pnts.x;
			mouseY = pnts.y;
            if (Corner && !CornerFirst) {
//				Corner = FALSE;
				CornerFirst = TRUE;
				XorBox(hWnd,mouseX4,mouseY4,mouseX3,mouseY3);
			}
			if (Corner) Corner = FALSE;
			ResumeThread(ThreadHandle);
			break;
		case WM_LBUTTONUP:
			SuspendThread(ThreadHandle);
			mouseDown = FALSE;
			ResumeThread(ThreadHandle);
			break;
		case WM_RBUTTONDOWN:
			SuspendThread(ThreadHandle);
			mouseRDown = TRUE;
			ResumeThread(ThreadHandle);
			break;
		case WM_RBUTTONUP:
			SuspendThread(ThreadHandle);
			mouseDown = FALSE;
			ResumeThread(ThreadHandle);
			break;
		case WM_MOUSEMOVE:
			SuspendThread(ThreadHandle);
			if (!Corner) ;
			else {
			    pnts = MAKEPOINTS(lp);
                mouseX2 = pnts.x;
			    mouseY2 = pnts.y;
				if (!CornerFirst) XorBox(hWnd,mouseX4,mouseY4,mouseX3,mouseY3);
				else CornerFirst = FALSE;
				XorBox(hWnd,mouseX4,mouseY4,mouseX2,mouseY2);
				mouseX3 = mouseX2;
				mouseY3 = mouseY2;
			}
			ResumeThread(ThreadHandle);
			break;
	    case WM_CREATE:
			// zʂ̎擾
			maxX = GetSystemMetrics(SM_CXSCREEN);
			maxY = GetSystemMetrics(SM_CYSCREEN);
			hdc = GetDC(hWnd);
			memdc = CreateCompatibleDC(hdc);
			hbit = CreateCompatibleBitmap(hdc,maxX,maxY);
			SelectObject(memdc,hbit);
			hbrush = (HBRUSH)GetStockObject(WHITE_BRUSH);
			SelectObject(memdc,hbrush);
			PatBlt(memdc,0,0,maxX,maxY,PATCOPY);
			ReleaseDC(hWnd,hdc);
			str[0] = '\0';
			cl = (CELL *)calloc(CELL_SIZE,sizeof(CELL));
			if (cl == NULL) {
				MessageBox(hWnd,TEXT("Z̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			FreeCellSize = CELL_SIZE;
			strArea = (TCHAR *)malloc(STRING_SIZE * 2L);
			if (strArea == NULL) {
				MessageBox(hWnd,TEXT("XgÖ̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
#if GC
			nArea = (AFLOAT *)calloc(NUMBER_SIZE,sizeof(AFLOAT));

#else
			nArea = (float *)calloc(NUMBER_SIZE,sizeof(float));
#endif
			if (nArea == NULL) {
				MessageBox(hWnd,TEXT("l̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			FreeNumberSize = NUMBER_SIZE;
			sv = (SYMVAL *)calloc(GLOBAL_SIZE,sizeof(SYMVAL));
			if (sv == NULL) {
				MessageBox(hWnd,TEXT("O[oϐ̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			fv = (SYMVAL *)calloc(FUNCTION_SIZE,sizeof(SYMVAL));
			if (fv == NULL) {
				MessageBox(hWnd,TEXT("֐̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
#if GC
			CellStack = (CELL **)calloc(CELL_STACK_SIZE,sizeof(CELL *));
			if (CellStack == NULL) {
				MessageBox(hWnd,TEXT("ZX^bN̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
/*			NumberStack = (AFLOAT **)calloc(NUMBER_STACK_SIZE,sizeof(AFLOAT *));
			if (NumberStack == NULL) {
				MessageBox(hWnd,TEXT("lX^bN̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}*/
			LocStack = (SYMVAL **)calloc(LOC_STACK_SIZE,sizeof(SYMVAL *));
			if (LocStack == NULL) {
				MessageBox(hWnd,TEXT("[JX^bN̈̊lɎs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			curCellStack = CellStack; /*curNumberStack = NumberStack;*/ curLocStack = LocStack;
			InitCellAndNumber();
#endif
			curCl = cl; curStr = strArea; curN = nArea; curSv = sv; curFv = fv;
			e = getString(TEXT("NIL"));
			NILCell = getCell();
			NILCell->attr = 's';
			NILCell->car = (CELL *)e;
			e = getString(TEXT("T"));
			TCell = getCell();
			TCell->attr = 's';
			TCell->car = (CELL *)e;
			if (!initSymval()) {
				MessageBox(hWnd,TEXT("Ɏs܂"),TEXT("G["),MB_OK);
				SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
//			GetClientRect(hWnd,&rc);
//			centerX = (rc.right - rc.left) / (float)2.0;
//			centerY = (rc.bottom - rc.top) / (float)2.0;
            hPen = CreatePen(PS_SOLID,0,RGB(0,255,0));
            hPenL = CreatePen(PS_SOLID,0,RGB(0,0,0));
            hPen1 = CreatePen(PS_SOLID,0,RGB(0,0,255));
            hPen2 = CreatePen(PS_SOLID,0,RGB(0,255,0));
            hPen3 = CreatePen(PS_SOLID,0,RGB(0,255,255));
            hPen4 = CreatePen(PS_SOLID,0,RGB(255,0,0));
            hPen5 = CreatePen(PS_SOLID,0,RGB(255,0,255));
            hPen6 = CreatePen(PS_SOLID,0,RGB(255,255,0));
            hPen7 = CreatePen(PS_SOLID,0,RGB(255,255,255));
#if GC
		    IncCellStack(NULL);
//		    *curNumberStack++ = NULL;
#endif

			if (!load(TEXT("src\\tursys"),0,0)) {
			    MessageBox(hWnd,TEXT("tursys.LSP̓ǂݍ݂Ɏs܂"),TEXT("G["),MB_OK);
			    SendMessage(hWnd,WM_CLOSE,0,0);
				break;
			}
			break;
	    case WM_COMMAND:
			switch (LOWORD(wp)) {
			    case IDM_DUMMY:
				    break;
#if USE_PRINTER
			    case IDM_PRINTOUT:
//					MessageBox(hWnd,TEXT("printer"),TEXT(""),MB_OK);
					turPrintOut();
					break;
#endif
				case IDM_WRITE:
					turWrite();
					break;
				case IDM_READ:
					turRead();
					break;
				case IDM_HELP:
			        MessageBox(hWnd,TEXT("turLisp version 3.15 copyright (c) 2013-2014 rr"),TEXT("o[W"),MB_OK);
					break;
			    case IDM_DIALOG:
					if (SuspendThread(ThreadHandle) != -1) {
						ResumeThread(ThreadHandle);
						MessageBox(hWnd,TEXT("LispvO̎słB"),TEXT("G["),MB_OK);
						break;
					}
                    for (;;) {
						id = DialogBox(hInst,MyDbStr,hWnd,(DLGPROC)DialogFunc);
						if (id == 0) {
							SendMessage(hWnd,WM_CLOSE,0,0);
							goto Escape2;
						}
						SkipTerm(lineStr,str);
						if (CheckBrace(lineStr))
							if (MakeQuoteText(lineStr,BUFLEN - 1)) break;
					}
					//MessageBox(hWnd,lineStr,TEXT(""),MB_OK);
#if GC
					IncCellStack(NULL);
//					*curNumberStack++ = NULL;
#endif
					top = readFromString(lineStr);
					if (top == NULL) goto Escape2;
					gtop = top;
					ThreadHandle = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)Execute,(LPVOID)hWnd,0,&Tid);
//					Execute();
                Escape2:
					break;
			}
			break;
	    case WM_PAINT:
			hdc = BeginPaint(hWnd,&ps);
			BitBlt(hdc,0,0,maxX,maxY,memdc,0,0,SRCCOPY);
			if (First) {
			    GetClientRect(hWnd,&rc);                       // Add on 2013.10.28
			    centerX = (rc.right - rc.left) / (float)2.0;   // Add on 2013.10.28
			    centerY = (rc.bottom - rc.top) / (float)2.0;   // Add on 2013.10.28
		        MoveToEx(hdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
		        MoveToEx(memdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
				XorTurtle(hdc);
				First = FALSE;
			}
//			Arc(hdc,0,0,400,300,0,0,0,0);
			EndPaint(hWnd,&ps);
			break;
		case WM_CLOSE:
			DestroyWindow(hWnd);
			break;
		case WM_DESTROY:
			free(fv);
			free(sv);
			free(nArea);
			free(strArea);
			free(cl);
			DeleteObject(hPen);
			DeleteObject(hPenL);
			DeleteObject(hPen1);
			DeleteObject(hPen2);
			DeleteObject(hPen3);
			DeleteObject(hPen4);
			DeleteObject(hPen5);
			DeleteObject(hPen6);
			DeleteObject(hPen7);
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd,msg,wp,lp);
	}
	return 0;
}

#if GC
void InitCellAndNumber(void)
{
	CELL *p;
	long i;
	AFLOAT *q;

	p = cl;
	for (i = 0;i < CELL_SIZE;i++) {
		p->gc = 'e';
		p++;
	}
	q = nArea;
	for (i = 0;i < NUMBER_SIZE;i++) {
		q->gc = 'e';
		q++;
	}
}

CELL *IncCellStack(CELL *c)
{
	if (curCellStack - CellStack >= CELL_STACK_SIZE - 1) {
		MessageBox(hwnd,TEXT("ZX^bNtłBI܂"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		return NULL;
	}
	*curCellStack++ = c;
	return c;
}

int IncLocStack(SYMVAL *loc,long len)
{
	long i;

	for (i = 0;i < len;i++) {
    	if (curLocStack - LocStack >= LOC_STACK_SIZE - 1) {
	    	MessageBox(hwnd,TEXT("[JX^bNtłBI܂"),TEXT("G["),MB_OK);
		    SendMessage(hwnd,WM_CLOSE,0,0);
		    return -1;
	    }
		*curLocStack++ = loc;
		loc++;
	}
	return 0;
}

void gc(void)
{
	CELL *p;
	CELL **q;
	SYMVAL **r;
	AFLOAT *a;
	SYMVAL *b;
    long k = 0,k2 = 0,i;
	TCHAR buf[200];
	char c;

	p = cl;
	for (i = 0;i < CELL_SIZE;i++) {
		p->gc = 'e';
		p++;
	}
	a = nArea;
	for (i = 0;i < NUMBER_SIZE;i++) {
		a->gc = 'e';
	    a++;
	}
	q = CellStack;
	while (q != curCellStack) {
		if (*q != NULL) {
			Disable(*q);
		}
		q++;
	}
	r = LocStack;
	while (r != curLocStack) {
		if (*r != NULL) {
//			MessageBox(hwnd,(*r)->sym,TEXT(""),MB_OK);
			Disable((*r)->val);
		}
		r++;
	}
	b = sv;
	while (b != curSv) {
        Disable(b->val);
		b++;
	}
	b = fv;  // Add
	while (b != curFv) {
        Disable(b->val);
		b++;
	}
	p = cl;
	for (i = 0;i < CELL_SIZE;i++) {
		if (p->gc == 'd') k++;
		p++;
	}
	a = nArea;
	for (i = 0;i < NUMBER_SIZE;i++) {
		if (a->gc == 'd') k2++;
	    a++;
	}
	if (GetToEndCell) c = '*';
	else c = ' ';
	FreeCellSize = CELL_SIZE - k;
	FreeNumberSize = NUMBER_SIZE - k2;
	wsprintf(buf,TEXT("gc: gp̃Z %d gp̐l̐ %d %c"),k,k2,c);
    SetWindowText(hwnd,buf);
//	MessageBox(hwnd,buf,TEXT(""),MB_OK);
}

void Disable(CELL *p)
{
	if (p->attr == 's') p->gc = 'd';
	else if (p->attr == 'n') {
		p->gc = 'd';
		((AFLOAT *)(p->car))->gc = 'd';
	}
	else if (p->attr == 'l') {
		p->gc = 'd';
		Disable(p->car);
		Disable(p->cdr);
	}
}
#endif

CELL *getPoint(void)
{
    CELL *p,*q,*r1,*r2;
	AFLOAT *k,*k2;

//	while (mouseDown) SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
//	while (!mouseDown) SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
//	SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
//	if (mouseRDown) return NILCell;
    do {
		SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
	} while (mouseDown);
    do {
    	if (mouseRDown) {
            mouseRDown = FALSE;
			return NILCell;
		}
		SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
	} while (!mouseDown);
	p = getCell(); if (p == NULL) return NULL;
	p->attr = 'n';
	k = getNumber((float)mouseX - centerX); if (k == NULL) return NULL;
	p->car = (CELL *)k;
	q = getCell(); if (q == NULL) return NULL;
	q->attr = 'n';
	k2 = getNumber((float)mouseY - centerY); if (k2 == NULL) return NULL;
	q->car = (CELL *)k2;
	r1 = getCell(); if (r1 == NULL) return NULL;
	r2 = getCell(); if (r2 == NULL) return NULL;
	r1->attr = 'l';
	r2->attr = 'l';
	r1->car = p;
	r1->cdr = r2;
	r2->car = q;
	r2->cdr = NILCell;
	return r1;
}

CELL *getCorner(CELL *a)
{
    CELL *p,*q,*r1,*r2;
	AFLOAT *k,*k2;

//	mouseX2 = mouseX; mouseY2 = mouseY;
	if (a->attr != 'l') goto corerror;
	if ((a->car)->attr != 'n') goto corerror;
	mouseX3 = mouseX4 = (int)(((AFLOAT *)((a->car)->car))->f + centerX);
	a = a->cdr;
	if (a->attr != 'l') goto corerror;
	if ((a->car)->attr != 'n') goto corerror;
	mouseY3 = mouseY4 = (int)(((AFLOAT *)((a->car)->car))->f + centerY);
	do {
		SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
	} while (mouseDown);
	Corner = TRUE;
    do {
		SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_DUMMY,0),0);
	} while (!mouseDown);
	p = getCell(); if (p == NULL) return NULL;
	p->attr = 'n';
	k = getNumber((float)mouseX3 - centerX); if (k == NULL) return NULL;
	p->car = (CELL *)k;
	q = getCell(); if (q == NULL) return NULL;
	q->attr = 'n';
	k2 = getNumber((float)mouseY3 - centerY); if (k2 == NULL) return NULL;
	q->car = (CELL *)k2;
	r1 = getCell(); if (r1 == NULL) return NULL;
	r2 = getCell(); if (r2 == NULL) return NULL;
	r1->attr = 'l';
	r2->attr = 'l';
	r1->car = p;
	r1->cdr = r2;
	r2->car = q;
	r2->cdr = NILCell;
	return r1;
corerror:
	MessageBox(hwnd,TEXT("_ZbgĂ܂B"),TEXT("G["),MB_OK);
	return NULL;
}

void XorBox(HWND hwnd,short x1,short y1,short x2,short y2)
{
	HDC hdc;

	hdc = GetDC(hwnd);
	if (turtleShowing) XorTurtle(hdc);
	SetROP2(hdc,R2_NOT);
	MoveToEx(hdc,x1,y1,NULL);
	LineTo(hdc,x2,y1);
	LineTo(hdc,x2,y2);
	LineTo(hdc,x1,y2);
	LineTo(hdc,x1,y1);
	SetROP2(memdc,R2_NOT);
	MoveToEx(memdc,x1,y1,NULL);
	LineTo(memdc,x2,y1);
	LineTo(memdc,x2,y2);
	LineTo(memdc,x1,y2);
	LineTo(memdc,x1,y1);
	if (turtleShowing) XorTurtle(hdc);
	ReleaseDC(hwnd,hdc);
}

CELL *arc(CELL *p,SYMVAL *loc,long locn)
{
	CELL *q;
	float x1,y1,x2,y2,x3,y3,x4,y4;

	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	x1 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	y1 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	x2 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	y2 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	x3 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	y3 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	x4 = ((AFLOAT *)(q->car))->f;
	p = p->cdr;
	if (p->attr != 'l') return NULL;
	q = p->car; if ((q = eval(q,loc,locn)) == NULL) return NULL;
	if (q->attr != 'n') return NULL;
	y4 = ((AFLOAT *)(q->car))->f;

	x1 += centerX; x2 += centerX; x3 += centerX; x4 += centerX;
    y1 += centerY; y2 += centerY; y3 += centerY; y4 += centerY;

	if (turtleShowing) XorTurtle(ghdc);
	Arc(ghdc,(int)x1,(int)y1,(int)x2,(int)y2,(int)x3,(int)y3,(int)x4,(int)y4);
	Arc(memdc,(int)x1,(int)y1,(int)x2,(int)y2,(int)x3,(int)y3,(int)x4,(int)y4);
	if (turtleShowing) XorTurtle(ghdc);

	return TCell;
}

DWORD Execute(LPVOID param)
{
	POINT pnt;
	CELL *top;
	TCHAR *e;
	HWND hWnd;

	hWnd = (HWND)param;
	
					ghdc = GetDC(hWnd);
				    switch (penColor) {
				        case 0: SelectObject(ghdc,hPenL); SelectObject(memdc,hPenL); break;
				        case 1: SelectObject(ghdc,hPen1); SelectObject(memdc,hPen1); break;
				        case 2: SelectObject(ghdc,hPen2); SelectObject(memdc,hPen2); break;
				        case 3: SelectObject(ghdc,hPen3); SelectObject(memdc,hPen3); break;
				        case 4: SelectObject(ghdc,hPen4); SelectObject(memdc,hPen4); break;
				        case 5: SelectObject(ghdc,hPen5); SelectObject(memdc,hPen5); break;
				        case 6: SelectObject(ghdc,hPen6); SelectObject(memdc,hPen6); break;
				        case 7: SelectObject(ghdc,hPen7); SelectObject(memdc,hPen7); break;
				    }
		            MoveToEx(ghdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
		            MoveToEx(memdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
					top = eval(gtop,0,0);
					if (top == NULL) goto Escape;
					//
					lstrcpy((LPWSTR)TitleStr,(LPCWSTR)TEXT("turLisp - "));
					e = TitleStr;
					while (*e != '\0') e++;
					forPrint(top,e);
					SetWindowText(hWnd,(LPCWSTR)TitleStr);
                Escape:
					ReleaseDC(hWnd,ghdc);
#if GC
	while (*(--curCellStack) != NULL);
//	while (*(--curNumberStack) != NULL);
#endif
	return 0;
}

BOOL CALLBACK DialogFunc(HWND hdwnd,UINT msg,WPARAM wp,LPARAM lp)
{
	static HWND hParent;

	switch (msg) {
	    case WM_INITDIALOG:
			hParent = GetParent(hdwnd);
			SetDlgItemText(hdwnd,IDD_EB1,(LPCWSTR)str);
			return 1;
		case WM_COMMAND:
			switch (LOWORD(wp)) {
		        case IDD_CLEAR:
//					lstrcpy((LPWSTR)str,"");
					str[0] = '\0';
					SetDlgItemText(hdwnd,IDD_EB1,(LPCWSTR)str);
					break;
				case IDD_EXEC:
					GetDlgItemText(hdwnd,IDD_EB1,(LPWSTR)str,BUFLEN - 1);
					EndDialog(hdwnd,1);
					break;
				case IDCANCEL:
					EndDialog(hdwnd,0);
					break;
			}
			return 1;
	}
	return 0;
}

void SkipTerm(TCHAR *ns,TCHAR *s)
{
	TCHAR *p;

	p = ns;
	while (*s != '\0') {
		if (*s == 0x0d || *s == 0x0a) { *p = ' '; }
		else { *p = *s; }
		p++; s++;
	}
	*p = '\0';
}

BOOL CheckBrace(TCHAR *s)
{
	int i,len,ct;

	s = SkipSpc(s);
	if (s[0] == '\0') return FALSE;
	if (s[0] == ')') {
		MessageBox(hwnd,TEXT(")܂"),TEXT("G["),MB_OK);
		return FALSE;
	}
	if (s[0] != '(') return TRUE;
	len = lstrlen((LPCWSTR)s); ct = 0;
	for (i = 0;i < len;i++) {
		if (s[i] == '(') ct++;
		else if (s[i] == ')') {
			ct--;
			if (ct < 0) {
        		MessageBox(hwnd,TEXT(")܂"),TEXT("G["),MB_OK);
				return FALSE;
			}
		}
		if (sizeof(TCHAR) == 1)
		   if (isKanji(s + i)) i++;
	}
	if (ct != 0) {
		MessageBox(hwnd,TEXT(")܂"),TEXT("G["),MB_OK);
		return FALSE;
	}
	return TRUE;
}

TCHAR *SkipSpc(TCHAR *s)
{
	while (*s == ' ') s++;
	return s;
}

BOOL isKanji(TCHAR *str)
{
	if (((TCHAR)0x81 <= *str && *str <= (TCHAR)0x9f) ||
		((TCHAR)0xe0 <= *str && *str <= (TCHAR)0xfc) ) {
		return TRUE;
	}
	return FALSE;
}

/*
CELL *getCell(void)
{
	CELL *p;

	if (curCl - cl >= CELL_SIZE - 1) {
		MessageBox(hwnd,TEXT("Z̈悪tłBI܂B"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		return NULL;
	}
	p = curCl++;
	return p;
}
*/

CELL *getCell(void)
{
	CELL *p;
	long i;

	for (i = 0;i < CELL_SIZE - 1;i++) {
	    if (curCl->gc == 'e') {
			p = curCl++;
            if (curCl == cl + CELL_SIZE - 1) {
				curCl = cl;
				GetToEndCell = TRUE;
			}
            p->gc = 'd';
			FreeCellSize--;
			return p;
		}
		curCl++;
        if (curCl == cl + CELL_SIZE - 1) {
			curCl = cl;
			GetToEndCell = TRUE;
		}
	}
    MessageBox(hwnd,TEXT("Z̈悪tłBI܂B"),TEXT("G["),MB_OK);
	SendMessage(hwnd,WM_CLOSE,0,0);
	return NULL;
}

#if GC
/*
AFLOAT *getNumber(float f)
{
	AFLOAT *p;

	if (curN - nArea >= NUMBER_SIZE - 1) {
		MessageBox(hwnd,TEXT("l̈悪tłBI܂B"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		return NULL;
	}
	p = curN;
    curN->f = f;
	curN++;
	return p;
}
*/
AFLOAT *getNumber(float f)
{
	AFLOAT *p;
	long i;

	for (i = 0;i < NUMBER_SIZE - 1;i++) {
	    if (curN->gc == 'e') {
			p = curN++;
            if (curN == nArea + NUMBER_SIZE - 1) curN = nArea;
            p->gc = 'd';
			p->f = f;
			FreeNumberSize--;
			return p;
		}
		curN++;
        if (curN == nArea + NUMBER_SIZE - 1) curN = nArea;
	}
    MessageBox(hwnd,TEXT("l̈悪tłBI܂B"),TEXT("G["),MB_OK);
	SendMessage(hwnd,WM_CLOSE,0,0);
	return NULL;
}

#else
float *getNumber(float f)
{
	float *p;

	if (curN - nArea >= NUMBER_SIZE - 1) {
		MessageBox(hwnd,TEXT("l̈悪tłBI܂B"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		*curN = 0.0;
		return NULL;
	}
	p = curN;
	*curN = f;
	curN++;
	return p;
}
#endif

TCHAR *getString(TCHAR *str)
{
	int len;
	TCHAR *p;

	if ((p = StrExist(str)) != NULL) return p; // Add on 2013.10.18
	len = lstrlen((LPCWSTR)str);
	if (curStr + len + 2 - strArea >= STRING_SIZE) {
		MessageBox(hwnd,TEXT("XgÖ悪tłBI܂B"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		*curStr = '\0';
		return NULL;
	}
	lstrcpy((LPWSTR)curStr,(LPCWSTR)str);
	p = curStr;
	curStr += len + 1;
	return p;
}

TCHAR *StrExist(TCHAR *s)
{
	TCHAR *p;

	p = strArea;
	while (p != curStr) {
        if (!lstrcmp((LPCWSTR)s,(LPCWSTR)p)) return p;
		p += lstrlen((LPCWSTR)p) + 1;
	}
	return NULL;
}

CELL *readFromString(TCHAR *str)
{
	TCHAR *s,*u,*e,*s1,*carS,*cdrS;
	CELL *p;
#if GC
	float f;
	AFLOAT *k;
#else
	float f,*k;
#endif
	int buflen;

//MessageBox(hwnd,(LPCWSTR)str,(LPCWSTR)TEXT(""),MB_OK);
	buflen = lstrlen((LPCWSTR)str) + 2;
	buflen = buflen * 2;
	s = (TCHAR *)malloc(buflen);
	u = (TCHAR *)malloc(buflen);
	s1 = (TCHAR *)malloc(buflen);
	carS = (TCHAR *)malloc(buflen);
	cdrS = (TCHAR *)malloc(buflen);
	NewString(s,str);
	if (!isListString(s)) {
		getCarString(u,s);
		if (!(myisdigit(u[0]) || (u[0] == '-' && myisdigit(u[1])))) {
			e = getString(u); if (e == NULL) goto Error;
			p = getCell(); if (p == NULL) goto Error;
			p->attr = 's';
			p->car = (CELL *)e;
		}
		else {
			f = myatof(u);
			p = getCell(); if (p == NULL) goto Error;
			p->attr = 'n';
			k = getNumber(f); if (k == NULL) goto Error;
			p->car = (CELL *)k;
#if GC
	        if (!IncCellStack(p)) return NULL;
#endif
		}
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
		return p;
	}
	else if (s[0] == '(' && s[1] == ')') {
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
        return NILCell;
	}
	else {
		lstrcpy((LPWSTR)s1,(LPCWSTR)(s + 1));
		e = SkipSpc(s1);
		getCarString(carS,e);
		getCdrString(cdrS,e);
		p = getCell(); if (p == NULL) goto Error;
		p->attr = 'l';
		p->car = readFromString(carS);
        if (p->car == NULL) goto Error;
		e = SkipSpc(cdrS);
		lstrcpy((LPWSTR)s1,(LPCWSTR)TEXT("("));
		lstrcat((LPWSTR)s1,(LPCWSTR)e);
		p->cdr = readFromString(s1);
        if (p->cdr == NULL) goto Error;
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
#if GC
		if (!IncCellStack(p)) return NULL;
#endif
		return p;
	}
  Error:
		free(cdrS);
		free(carS);
		free(s1);
		free(u);
		free(s);
		return NULL;
}

void NewString(TCHAR *s2,TCHAR *s1)
{
	TCHAR *s,*p;

	s = SkipSpc(s1);
	if (s[0] == '(') {
		p = s + 1;
		p = SkipSpc(p);
		lstrcpy((LPWSTR)(s2 + 1),(LPCWSTR)p);
		s2[0] = '(';
		return;
	}
	lstrcpy((LPWSTR)s2,(LPCWSTR)s);
}

BOOL isListString(TCHAR *str)
{
	if (*str == '(') return TRUE;
	return FALSE;
}

void getCarString(TCHAR *u,TCHAR *str)
{
	int i,ct;

	if (*str == '(') {
		ct = 0;
		for (i = 0;i < lstrlen((LPCWSTR)str);i++) {
			if (str[i] == '(') ct++;
			else if (str[i] == ')') ct--;
			if (ct == 0) {
				mystrncpy(u,str,i + 1);
				u[i + 1] = '\0';
				return;
			}
			if (sizeof(TCHAR) == 1)
				if (isKanji(str + i)) i++;
		}
		MessageBox(hwnd,TEXT("Eʂ܂"),TEXT("G["),MB_OK);
		*u = '\0';
		return;
	}
	else {
		for (i = 0;i < lstrlen((LPCWSTR)str);i++) {
			if (str[i] == ' ' || str[i] == '(' || str[i] == ')') {
				mystrncpy(u,str,i);
				u[i] = '\0';
				return;
			}
			if (sizeof(TCHAR) == 1)
				if (isKanji(str + i)) i++;
		}
		lstrcpy((LPWSTR)u,(LPCWSTR)str);
	}
}

BOOL myisdigit(TCHAR c)
{
	if (sizeof(TCHAR) == 1 && isKanji(&c)) return FALSE;
    if (c >= 256) return FALSE;
	return isdigit(c);
}

void getCdrString(TCHAR *s,TCHAR *str)
{
	int ct,i;

	if (str[0] == '(') {
		ct = 0;
		for (i = 0;i < lstrlen((LPCWSTR)str);i++) {
			if (str[i] == '(') ct++;
			else if (str[i] == ')') ct--;
			if (ct == 0) {
				lstrcpy((LPWSTR)s,(LPCWSTR)(str + i + 1));
				return;
			}
			if (sizeof(TCHAR) == 1)
				if (isKanji(str + i)) i++;
		}
		MessageBox(hwnd,TEXT("Eʂ܂"),TEXT("G["),MB_OK);
        lstrcpy((LPWSTR)s,(LPCWSTR)TEXT(""));
		return;
	}
	else {
		for (i = 0;i < lstrlen((LPCWSTR)str);i++) {
			if (str[i] == ' ') {
				lstrcpy((LPWSTR)s,(LPCWSTR)(str + i + 1));
				return;
			}
			else if (str[i] == '(' || str[i] == ')') {
				lstrcpy((LPWSTR)s,(LPCWSTR)(str + i));
				return;
			}
			if (sizeof(TCHAR) == 1)
				if (isKanji(str + i)) i++;
		}
		lstrcpy((LPWSTR)s,(LPCWSTR)TEXT(""));
		return;
	}
}

void mystrncpy(TCHAR *n,TCHAR *s,int len)
{
	int i;

	for (i = 0;i < len;i++) {
		if (*s == '\0') { *n = '\0'; return; }
		*n++ = *s++;
	}
}

void forPrint(CELL *p,TCHAR *s)
{
	pN = 0;
	s[0] = '\0';
	printS(p,s);
}

BOOL printS(CELL *p,TCHAR *str)
{
	TCHAR buf[30];
	int len;

	if (p->attr == 's') {
		len = lstrlen((LPCWSTR)(TCHAR *)p->car);
		pN += len + 1;
		if (pN >= DISPBUFLEN - 1) return FALSE;
		lstrcat((LPWSTR)str,(LPCWSTR)(TCHAR *)p->car);
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(" "));
	}
	else if (p->attr == 'n') {
#if GC
		myftoa(buf,(float)(((AFLOAT *)(p->car))->f));
#else
		myftoa(buf,*((float *)p->car));
#endif
		len = lstrlen((LPCWSTR)buf);
		pN += len + 1;
		if (pN >= DISPBUFLEN - 1) return FALSE;
		lstrcat((LPWSTR)str,(LPCWSTR)buf);
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(" "));
	}
	else if (p->attr == 'l') {
		pN++;
		if (pN >= DISPBUFLEN - 1) return FALSE;
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT("("));
		if (!printS2(p,str)) return FALSE;
		pN++;
		if (pN >= DISPBUFLEN - 1) return FALSE;
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(")"));
	}
	return TRUE;
}

BOOL printS2(CELL *p,TCHAR *str)
{
	if (!printS(p->car,str)) return FALSE;
	if (!printS3(p->cdr,str)) return FALSE;
	return TRUE;
}

BOOL printS3(CELL *p,TCHAR *str)
{
	TCHAR b[30];
	int len;

	if (p->attr == 's' && lstrcmp((LPCWSTR)(TCHAR *)p->car,(LPCWSTR)TEXT("NIL"))) {
		len = lstrlen((LPCWSTR)(TCHAR *)p->car);
		pN += len + 3;
		if (pN >= DISPBUFLEN - 1) return FALSE;
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(". "));
		lstrcat((LPWSTR)str,(LPCWSTR)(TCHAR *)p->car);
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(" "));
	}
	else if (p->attr == 'n') {
#if GC
		myftoa(b,((AFLOAT *)(p->car))->f);
#else
		myftoa(b,*((float *)p->car));
#endif
		len = lstrlen((LPCWSTR)b);
		pN += len + 3;
		if (pN >= DISPBUFLEN - 1) return FALSE;
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(". "));
		lstrcat((LPWSTR)str,(LPCWSTR)b);
		lstrcat((LPWSTR)str,(LPCWSTR)TEXT(" "));
	}
	else if (p->attr == 'l') {
		if (!printS2(p,str)) return FALSE;
	}
	return TRUE;
}

void myftoa(TCHAR *b,float v)
{
	char buf[30];
	int i,len;

	sprintf_s(buf,"%f",v);
	len = strlen(buf);
	for (i = 0;i < len;i++) b[i] = (TCHAR)buf[i];
	b[i] = '\0';
}

float myatof(TCHAR *b)
{
	TCHAR b1[40];
	char buf[40];
	int i,len;

	mystrncpy(b1,b,40);
	b1[39] = '\0';
	len = lstrlen((LPCWSTR)b1);
	for (i = 0;i < len;i++) buf[i] = (char)b1[i];
	buf[i] = '\0';
	return (float)atof(buf);
}

CELL *eval(CELL *top,SYMVAL *loc,long locn)
{
	CELL *p;

	p = evalu(top,loc,locn);
	if (p != NULL && p->attr != 's' /*&& p != NULL*/)
		if (!IncCellStack(p)) return NULL;
	return p;
}

CELL *evalu(CELL *top,SYMVAL *loc,long locn)
{
	CELL *p,*x,*y;
	long n2;
	SYMVAL *r,*temploc;
	long len;
#if GC
    AFLOAT *n;
#else
	float *n;
#endif
	int col;
#if GC
	AFLOAT *k;
#else
	float *k;
#endif
	DWORD Millisec;

	if (top->attr == 'l') {
		if ((top->car)->attr != 's') goto serror;
		else {
			if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("fd"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return fd(eval((top->cdr)->car,loc,locn));
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("lt"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return lt(eval((top->cdr)->car,loc,locn));
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("rt"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return rt(eval((top->cdr)->car,loc,locn));
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("bk"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return bk(eval((top->cdr)->car,loc,locn));
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("pen"))) {
                if (penDown) return TCell;
				return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("pu"))) {
				penDown = FALSE;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("pd"))) {
				penDown = TRUE;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("inkey"))) {
			    p = getCell(); if (p == NULL) return NULL;
			    p->attr = 'n';
			    k = getNumber((float)KeyValue); if (k == NULL) return NULL;
			    p->car = (CELL *)k;
				return p;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("setpos"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				return setpos(x,y);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("ht"))) {
				if (turtleShowing) {
					XorTurtle(ghdc);
					turtleShowing = FALSE;
					return TCell;
				}
				return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("xcor"))) {
				if (!(x = getCell())) return NULL;
				if (!(n = getNumber(penX))) return NULL;
				x->attr = 'n';
				x->car = (CELL *)n;
				return x;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("ycor"))) {
				if (!(x = getCell())) return NULL;
				if (!(n = getNumber(penY))) return NULL;
				x->attr = 'n';
				x->car = (CELL *)n;
				return x;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("getangle"))) {
				if (!(x = getCell())) return NULL;
				if (!(n = getNumber((float)(penAngle - 90.0)))) return NULL;
				x->attr = 'n';
				x->car = (CELL *)n;
				return x;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("setangle"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (x->attr != 'n') { MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK); return NULL; }
				if (turtleShowing) XorTurtle(ghdc);
#if GC
				penAngle = (float)(((AFLOAT *)(x->car))->f + 90.0);
#else
				penAngle = (float)(*(float *)(x->car) + 90.0);
#endif
				if (penAngle < -180.0) penAngle = TrueAngleMinus(penAngle);
				else if (penAngle >= 180.0) penAngle = TrueAnglePlus(penAngle);
				if (turtleShowing) XorTurtle(ghdc);
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("st"))) {
				if (!turtleShowing) {
					XorTurtle(ghdc);
					turtleShowing = TRUE;
					return TCell;
				}
				return NILCell;
			}
			else if (!lstrcmp((LPCWSTR)(TCHAR *)((top->car)->car),TEXT("quote"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return (top->cdr)->car;
			}
			else if (!lstrcmp((LPCWSTR)(TCHAR *)((top->car)->car),TEXT("car"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 'l') goto serror;
				return top->car;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("cdr"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 'l') goto serror;
				return top->cdr;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("cons"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(p = getCell())) return NULL;
				p->attr = 'l';
				if (!(p->car = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(p->cdr = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				return p;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("print"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr == 'l' && (((top->cdr)->cdr)->cdr)->attr == 'l') {
					if (!(x = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
					if (!(y = eval((((top->cdr)->cdr)->cdr)->car,loc,locn))) return NULL;
					if (!(p = eval((top->cdr)->car,loc,locn))) return NULL;
					if (x->attr == 'n' && y->attr == 'n') {
#if GC
						printXY(p,(int)(((AFLOAT *)(x->car))->f),(int)(((AFLOAT *)(y->car))->f));
#else
						printXY(p,(int)(*(float *)(x->car)),(int)(*(float *)(y->car)));
#endif
						return p;
					}
					else {
						printXY(p,0,0);
						return p;
					}
				}
				else {
					if (!(p = eval((top->cdr)->car,loc,locn))) return NULL;
                    printXY(p,0,0);
					return p;
				}
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("set"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (x->attr != 's') goto serror;
				if ((n2 = getLocal(loc,locn,(TCHAR *)x->car)) != -1) {
					loc[n2].val = y;
					return y;
				}
				else {
					if ((n2 = getSymVal2((TCHAR *)x->car)) == -1) return NULL;
					sv[n2].sym = (TCHAR *)x->car;
					sv[n2].val = y;
					return y;
				}
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("setq"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
	setq:
				x = (top->cdr)->car;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (x->attr != 's') goto serror;
				if ((n2 = getLocal(loc,locn,(TCHAR *)x->car)) != -1) {
					loc[n2].val = y;
					return y;
				}
				else {
					if ((n2 = getSymVal2((TCHAR *)x->car)) == -1) return NULL;
					sv[n2].sym = (TCHAR *)x->car;
					sv[n2].val = y;
					return y;
				}
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("and"))) {
				return tand(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("or"))) {
				return tor(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("atom"))) {
				if ((top->cdr)->attr != 'l') goto serror;
                if (!(p = eval((top->cdr)->car,loc,locn))) return NULL;
				if (p->attr != 'l') return TCell;
				else return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("numberp"))) {
				if ((top->cdr)->attr != 'l') goto serror;
                if (!(p = eval((top->cdr)->car,loc,locn))) return NULL;
				if (p->attr == 'n') return TCell;
				else return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("eval"))) {
				if ((top->cdr)->attr != 'l') goto serror;
                if (!(p = eval((top->cdr)->car,loc,locn))) return NULL;
				return eval(p,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("*"))) {
				return times(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("+"))) {
				return plus(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("-"))) {
				return minus(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("/"))) {
				return divide(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("="))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (x->attr != 'n' || y->attr != 'n') goto serror;
#if GC
				if (((AFLOAT *)(x->car))->f == ((AFLOAT *)(y->car))->f) return TCell;
#else
				if (*((float *)x->car) == *((float *)y->car)) return TCell;
#endif
				return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("eq"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (x->attr == 's') {
					if (y->attr != 's') return NILCell;
					if (!lstrcmp((TCHAR *)x->car,(TCHAR *)y->car)) return TCell;
					return NILCell;
				}
				else if (x->attr == 'n') {
					if (y->attr != 'n') return NILCell;
#if GC
					if (((AFLOAT *)(x->car))->f == ((AFLOAT *)(y->car))->f) return TCell;
#else
					if (*((float *)x->car) == *((float *)y->car)) return TCell;
#endif
					return NILCell;
				}
				else if (x->attr == 'l') {   // Add 2013.10.20
//					if (y->attr != 'l') return NILCell;
					if (x == y) return TCell;
					return NILCell;
				}
				return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("null"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(p = eval((top->cdr)->car,loc,locn))) return NULL;
				if (p->attr == 's' && !lstrcmp((TCHAR *)p->car,TEXT("NIL"))) return TCell;
				return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("progn"))) {
				return tprogn(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("minusp"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return minusp(eval((top->cdr)->car,loc,locn));
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("cond"))) {
				return condition(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("loop"))) {
				return loopBody(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("load"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 's') goto serror;
				return load((TCHAR *)(top->car),loc,locn);
			}
			else if (!lstrcmp((LPCWSTR)(TCHAR *)((top->car)->car),TEXT("random"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				return trandom(top);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("sqrt"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				return tsqrt(top);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("xwidth"))) {
				return xwidth();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("ywidth"))) {
				return ywidth();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("xcenter"))) {
				return xcenter();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("ycenter"))) {
				return ycenter();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("cs"))) {
				return tcs();
			}
			else if (!lstrcmp((LPCWSTR)(TCHAR *)((top->car)->car),TEXT("setpc"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 'n') goto serror;
#if GC
				col = (int)(((AFLOAT *)(top->car))->f);
#else
				col = (int)(*(float *)(top->car));
#endif
				switch (col) {
				    case 0: SelectObject(ghdc,hPenL); SelectObject(memdc,hPenL); break;
				    case 1: SelectObject(ghdc,hPen1); SelectObject(memdc,hPen1); break;
				    case 2: SelectObject(ghdc,hPen2); SelectObject(memdc,hPen2); break;
				    case 3: SelectObject(ghdc,hPen3); SelectObject(memdc,hPen3); break;
				    case 4: SelectObject(ghdc,hPen4); SelectObject(memdc,hPen4); break;
				    case 5: SelectObject(ghdc,hPen5); SelectObject(memdc,hPen5); break;
				    case 6: SelectObject(ghdc,hPen6); SelectObject(memdc,hPen6); break;
				    case 7: SelectObject(ghdc,hPen7); SelectObject(memdc,hPen7); break;
					default: goto serror;
				}
				penColor = col;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("setf"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
                if (((top->cdr)->car)->attr == 's') goto setq;
				return setf(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("putd"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(y = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (y->attr != 'l') goto serror;  // y : (lambda (x) (print x))
				y = y->cdr;
				if (y->attr != 'l') goto serror;  // y : ((x) (print x))
				if (x->attr != 's') goto serror;
				if (!(r = getFuncval((TCHAR *)(x->car)))) return NULL;
				if (!(r->sym = getString((TCHAR *)(x->car)))) return NULL;
				r->val = y;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("gethash"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				return gethash(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("remhash"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				return remhash(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("make-hash-table"))) {
				return MakeHashTable();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("defun"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(r = getFuncval((TCHAR *)(((top->cdr)->car)->car)))) return NULL;
				if (!(r->sym = getString((TCHAR *)(((top->cdr)->car)->car)))) return NULL;
				r->val = (top->cdr)->cdr;
				return TCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("funcall"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return funcall(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("apply"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				return apply(top->cdr,(top->cdr)->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("sleep"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(top = eval((top->cdr)->car,loc,locn))) return NULL;
				if (top->attr != 'n') goto serror;
#if GC
				Millisec = (DWORD)(((AFLOAT *)(top->car))->f);
#else
				Millisec = (DWORD)(*(float *)(top->car));
#endif
				Sleep(Millisec);
				return TCell;
			}
#if USE_PRINTER
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("printout"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if (!(linesCell = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(circlesCell = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_PRINTOUT,0),0);
				if (LineCircle) return TCell;
				else return NILCell;
			}
#endif

			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("writelc"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (((top->cdr)->cdr)->attr != 'l') goto serror;
				if ((((top->cdr)->cdr)->cdr)->attr != 'l') goto serror;
				if (!(linesCell = eval((top->cdr)->car,loc,locn))) return NULL;
				if (!(circlesCell = eval(((top->cdr)->cdr)->car,loc,locn))) return NULL;
				if (!(filenameCell = eval((((top->cdr)->cdr)->cdr)->car,loc,locn))) return NULL;
				SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_WRITE,0),0);
				if (LineCircle) return TCell;
				else return NILCell;
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("readlc"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(filenameCell = eval((top->cdr)->car,loc,locn))) return NULL;
				SendMessage(hwnd,WM_COMMAND,MAKEWPARAM(IDM_READ,0),0);
				return returnCell;
			}

#if GC
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("gc"))) {
				gc();
				return TCell;
			}
#endif
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("list"))) {
				return tlist(top->cdr,loc,locn);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("getpoint"))) {
				return getPoint();
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("getcorner"))) {
				if ((top->cdr)->attr != 'l') goto serror;
				if (!(x = eval((top->cdr)->car,loc,locn))) return NULL;
				return getCorner(x);
			}
			else if (!lstrcmp((TCHAR *)((top->car)->car),TEXT("arc"))) {
				p = arc(top->cdr,loc,locn);
				if (p == NULL) goto serror;
				return p;
			}
			else {
				r = getFuncval2((TCHAR *)((top->car)->car));
				if (r == NULL) {
					MessageBox(hwnd,TEXT("`̊֐ł"),TEXT("G["),MB_OK);
					return NULL;
				}
				len = tlength((r->val)->car);
				temploc = (SYMVAL *)calloc(len,sizeof(SYMVAL));
				if (temploc == NULL) {
					MessageBox(hwnd,TEXT("[Jϐ̈̊mۂɎs܂"),TEXT("G["),MB_OK);
					return NULL;
				}
				if (!initTemploc(temploc,len,(r->val)->car,top->cdr,loc,locn)) {
					MessageBox(hwnd,TEXT("܂"),TEXT("G["),MB_OK);
					free(temploc);
					return NULL;
				}

#if GC
			    IncCellStack(NULL);
//			    *curNumberStack++ = NULL;
			    if (IncLocStack(NULL,1) == -1) {
				    free(temploc);
				    return NULL;
			    }
			    if (IncLocStack(temploc,len) == -1) {
				    free(temploc);
				    return NULL;
			    }
				if (FreeCellSize < CELL_SIZE_MIN || FreeNumberSize < NUMBER_SIZE_MIN) gc();
#endif

				p = tprogn((r->val)->cdr,temploc,len);
#if GC
				while (*(--curLocStack) != NULL);
			    while (*(--curCellStack) != NULL);
//			    while (*(--curNumberStack) != NULL);
//				if (p->attr != 's') IncCellStack(p);    // Add on 2013.10.23
#endif
				free(temploc);
				return p;
			}
		}
	}
	else if (top->attr == 'n') return top;
	else if ((n2 = getLocal(loc,locn,(TCHAR *)top->car)) != -1) {
		return loc[n2].val;
	}
	else {
		n2 = getSymVal((TCHAR *)top->car);
		if (n2 == -1) {
			MessageBox(hwnd,TEXT("̕ϐɂ͑Ă܂"),TEXT("G["),MB_OK);
			return NULL;
		}
        return (sv + n2)->val;
	}
serror:
	MessageBox(hwnd,TEXT("@G["),TEXT("G["),MB_OK);
	return NULL;
}

CELL *tlist(CELL *p,SYMVAL *loc,long locn)
{
	CELL *s,*q,*r,*x;

	if (p->attr != 'l') return NILCell;
	if ((s = getCell()) == NULL) return NULL;
	q = s;
	for (;;) {
		if ((x = eval(p->car,loc,locn)) == NULL) return NULL;
		q->attr = 'l';
		q->car = x;
		p = p->cdr;
		if (p->attr != 'l') { q->cdr = NILCell; return s; }
		if ((r = getCell()) == NULL) return NULL;
		q->cdr = r;
		q = r;
	}
}

void printXY(CELL *p,int x,int y)
{
	RECT rc;

	forPrint(p,TitleStr);
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
	if (x == 0 && y == 0) {
		GetClientRect(hwnd,&rc);
		DrawText(ghdc,TitleStr,-1,&rc,DT_WORDBREAK);
		DrawText(memdc,TitleStr,-1,&rc,DT_WORDBREAK);
	}
	else {
		TextOut(ghdc,x,y,TitleStr,lstrlen(TitleStr));
		TextOut(memdc,x,y,TitleStr,lstrlen(TitleStr));
	}
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
}

long getLocal(SYMVAL *loc,long locn,TCHAR *s)
{
	long i;

	for (i = 0;i < locn;i++)
		if (!lstrcmp(s,(loc + i)->sym)) return i;
	return -1;
}

long getSymVal2(TCHAR *s)
{
	SYMVAL *p;
	long i;
	TCHAR *u;

	p = sv;
	i = 0;
	while (p != curSv) {
		if (!lstrcmp(p->sym,s)) return i;
		p++;
		i++;
	}
    if (curSv - sv >= GLOBAL_SIZE - 1) {
        MessageBox(hwnd,TEXT("O[oϐ̈悪sĂ܂BI܂B"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		return -1;
	}
	if (!(u = getString(s))) return -1;
	curSv->sym = u;
	curSv++;
	return i;
}

long getSymVal(TCHAR *s)
{
	SYMVAL *p;
	long i;

	p = sv;
	i = 0;
	while (p != curSv) {
		if (!lstrcmp(p->sym,s)) return i;
		p++;
		i++;
	}
	return -1L;
}

BOOL initSymval(void)
{
	TCHAR *s;

	if (!(s = getString(TEXT("NIL")))) return FALSE;
	curSv->sym = s;
	curSv->val = NILCell;
	curSv++;
	if (!(s = getString(TEXT("T")))) return FALSE;
	curSv->sym = s;
	curSv->val = TCell;
	curSv++;
    return TRUE;
}

CELL *tand(CELL *p,SYMVAL *loc,long locn)
{
	CELL *q;

	for (;;) {
		if (p->attr == 's' || p->attr == 'n') return TCell;
		if (!(q = eval(p->car,loc,locn))) return NULL;
		if (q->attr == 's' && !lstrcmp((TCHAR *)q->car,TEXT("NIL"))) return NILCell;
		p = p->cdr;
	}
}

CELL *tor(CELL *p,SYMVAL *loc,long locn)
{
	CELL *q;

	for (;;) {
		if (p->attr == 's' || p->attr == 'n') return NILCell;
		if (!(q = eval(p->car,loc,locn))) return NULL;
		if (q->attr == 's' && lstrcmp((TCHAR *)q->car,TEXT("NIL"))) return TCell;
		else if (q->attr == 'n') return TCell;
		p = p->cdr;
	}
}

CELL *times(CELL *s,SYMVAL *loc,long locn)
{
	float k = 1.0;
#if GC
    AFLOAT *f;
#else
	float *f;
#endif
	CELL *p;

	for (;;) {
		if (s->attr != 'l') break;
		if (!(p = eval(s->car,loc,locn))) return NULL;
		if (p->attr != 'n') {
			MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
			return NULL;
		}
#if GC
		k *= ((AFLOAT *)(p->car))->f;
#else
		k *= *((float *)p->car);
#endif
		s = s->cdr;
	}
	if (!(p = getCell())) return NULL;
	p->attr = 'n';
	if (!(f = getNumber(k))) return NULL;
	p->car = (CELL *)f;
	return p;
}

CELL *plus(CELL *s,SYMVAL *loc,long locn)
{
	float k = 0.0;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	CELL *p;

	for (;;) {
		if (s->attr != 'l') break;
		if (!(p = eval(s->car,loc,locn))) return NULL;
		if (p->attr != 'n') {
			MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
			return NULL;
		}
#if GC
		k += ((AFLOAT *)(p->car))->f;
#else
		k += *((float *)p->car);
#endif
		s = s->cdr;
	}
	if (!(p = getCell())) return NULL;
	p->attr = 'n';
	if (!(f = getNumber(k))) return NULL;
	p->car = (CELL *)f;
	return p;
}


CELL *minus(CELL *s,SYMVAL *loc,long locn)
{
	float k;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	CELL *p;

	if (s->attr != 'l') {
		MessageBox(hwnd,TEXT("܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if (!(p = eval(s->car,loc,locn))) return NULL;
	if (p->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	k = ((AFLOAT *)(p->car))->f;
#else
    k = *((float *)p->car);
#endif
	s = s->cdr;
	for (;;) {
		if (s->attr != 'l') break;
		if (!(p = eval(s->car,loc,locn))) return NULL;
		if (p->attr != 'n') {
			MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
			return NULL;
		}
#if GC
		k -= ((AFLOAT *)(p->car))->f;
#else
        k -= *((float *)p->car);
#endif
		s = s->cdr;
	}
	if (!(p = getCell())) return NULL;
	p->attr = 'n';
	if (!(f = getNumber(k))) return NULL;
	p->car = (CELL *)f;
	return p;
}

CELL *divide(CELL *s,SYMVAL *loc,long locn)
{
	float k;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	CELL *p;

	if (s->attr != 'l') {
		MessageBox(hwnd,TEXT("܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if (!(p = eval(s->car,loc,locn))) return NULL;
	if (p->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	k = ((AFLOAT *)(p->car))->f;
#else
    k = *((float *)p->car);
#endif
	s = s->cdr;
	for (;;) {
		if (s->attr != 'l') break;
		if (!(p = eval(s->car,loc,locn))) return NULL;
		if (p->attr != 'n') {
			MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
			return NULL;
		}
#if GC
		if (((AFLOAT *)(p->car))->f == 0.0) {
#else
		if (*((float *)p->car) == 0.0) {
#endif
			MessageBox(hwnd,TEXT("0ŏZ܂"),TEXT("G["),MB_OK);
			return NULL;
		}
#if GC
		k /= ((AFLOAT *)(p->car))->f;
#else
        k /= *((float *)p->car);
#endif
		s = s->cdr;
	}
	if (!(p = getCell())) return NULL;
	p->attr = 'n';
	if (!(f = getNumber(k))) return NULL;
	p->car = (CELL *)f;
	return p;
}

CELL *tprogn(CELL *s,SYMVAL *loc,long locn)
{
	CELL *p;

	p = NILCell;
	for (;;) {
		if (s->attr != 'l') return p;
		if (!(p = eval(s->car,loc,locn))) return NULL;
		s = s->cdr;
	}
}

CELL *minusp(CELL *s)
{
	if (s == NULL) return NULL;
	if (s->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	if (((AFLOAT *)(s->car))->f < 0.0) return TCell;
#else
	if (*(float *)s->car < 0.0) return TCell;
#endif
	return NILCell;
}

CELL *condition(CELL *s,SYMVAL *loc,long locn)
{
	CELL *p,*u;

	for (;;) {
		if (s->attr != 'l') return NILCell;
		u = s->car;
		if (u->attr != 'l') return NILCell;
		if (!(p = eval(u->car,loc,locn))) return NULL;
		if (!(p->attr == 's' && !lstrcmp((TCHAR *)p->car,TEXT("NIL")))) return tprogn(u->cdr,loc,locn);
		s = s->cdr;
	}
}

CELL *loopBody(CELL *s,SYMVAL *loc,long locn)
{
	CELL *e,*a,*b;

	for (;;) {
		e = s;
		for (;;) {
			if (e->attr != 'l') break;
			a = e->car;
			if (a->attr == 'l') {
				if ((a->car)->attr == 'l') {
					if (!(b = eval(a->car,loc,locn))) return NULL;
					if (!(b->attr == 's' && !lstrcmp((TCHAR *)b->car,TEXT("NIL")))) {
						return tprogn(a->cdr,loc,locn);
					}
					else ;
				}
				else if (!eval(a,loc,locn)) return NULL;
			}
			else if (!eval(a,loc,locn)) return NULL;
			e = e->cdr;
		}
	}
}

SYMVAL *getFuncval(TCHAR *s)
{
	SYMVAL *p;

	p = fv;
	while (p != curFv) {
		if (!lstrcmp(p->sym,s)) return p;
		p++;
	}
	if (curFv - fv >= FUNCTION_SIZE - 1) {
		MessageBox(hwnd,TEXT("֐̈悪tɂȂ܂BI܂B"),TEXT("G["),MB_OK);
		SendMessage(hwnd,WM_CLOSE,0,0);
		return NULL;
	}
	curFv++;
	return p;
}

SYMVAL *getFuncval2(TCHAR *s)
{
	SYMVAL *p;

	p = fv;
	while (p != curFv) {
		if (!lstrcmp(p->sym,s)) return p;
		p++;
	}
	return NULL;
}

long tlength(CELL *p)
{
	long i;

	i = 0;
	for (;;) {
		if (p->attr != 'l') return i;
		i++;
		p = p->cdr;
	}
}

BOOL initTemploc(SYMVAL *l,long len,CELL *s,CELL *v,SYMVAL *loc,long locn)
{
	CELL *p;
	long i;

	if (len < tlength(v)) return FALSE;
	p = s;
	for (i = 0;i < len;i++) {
		if ((p->car)->attr != 's') return FALSE;
		l[i].sym = (TCHAR *)((p->car)->car);
		l[i].val = NILCell;
		p = p->cdr;
	}
	for (i = 0;i < len;i++) {
		if (v->attr != 'l') break;
		if (!(l[i].val = eval(v->car,loc,locn))) return FALSE;
		v = v->cdr;
	}
	return TRUE;
}

CELL *load(TCHAR *name,SYMVAL *loc,long locn)
{
	int d;
	TCHAR fname[256];
	TCHAR msg[300];
	FILE *fp;

	lstrcpy(msg,name);
	lstrcat(msg,TEXT(".LSPǂݍ݂܂"));
	SetWindowText(hwnd,msg);
	lstrcpy(fname,name);
	lstrcat(fname,TEXT(".LSP"));
	_wfopen_s(&fp,fname,TEXT("rb"));
	if (fp == NULL) {
		MessageBox(hwnd,TEXT("t@CJƂł܂"),TEXT("G["),MB_OK);
		return NULL;
	}
//	MessageBox(hwnd,TEXT("succeeded to open"),TEXT(""),MB_OK);
	if (sizeof(TCHAR) == 2) {
	    if ((d = getc(fp)) == -1) {
		    MessageBox(hwnd,TEXT("unicodẽt@Cł͂܂"),TEXT("G["),MB_OK);
		    fclose(fp);
		    return NULL;
	    }
	    bom[0] = d;
	    if ((d = getc(fp)) == -1) {
		    MessageBox(hwnd,TEXT("unicodẽt@Cł͂܂"),TEXT("G["),MB_OK);
		    fclose(fp);
		    return NULL;
	    }
	    bom[1] = d;
	    if (!(bom[0] == 0xff && bom[1] == 0xfe) || (bom[1] == 0xff && bom[0] == 0xfe)) {
		    MessageBox(hwnd,TEXT("unicodẽt@Cł͂܂"),TEXT("G["),MB_OK);
		    fclose(fp);
		    return NULL;
	    }
	}
	if (!loading(fp,loc,locn)) {
		fclose(fp);
		return NULL;
	}
	fclose(fp);
	return TCell;
}

int getWChar(FILE *fp)
{
	int d1,d2;

	if (sizeof(TCHAR) == 2) {
        if ((d1 = getc(fp)) == -1) return -1; 
        if ((d2 = getc(fp)) == -1) return -1; 
	    if (bom[0] == 0xff) return d2 * 256 + d1;
	    else return d1 * 256 + d2;
	}
	else return getc(fp);
}

BOOL loading(FILE *fp,SYMVAL *loc,long locn)
{
	TCHAR buf[BUFLEN];
	CELL *top;

	for (;;) {
		if (!GetSExp(buf,fp)) return FALSE;
//MessageBox(hwnd,buf,TEXT(""),MB_OK);
		if (buf[0] == '\0') break;
		if (!MakeQuoteText(buf,BUFLEN - 1)) return FALSE;
//MessageBox(hwnd,buf,TEXT(""),MB_OK);
		if (!(top = readFromString(buf))) return FALSE;
		if (!eval(top,loc,locn)) return FALSE;
	}
	return TRUE;
}

BOOL GetSExp(TCHAR *buf,FILE *fp)
{
	int ch,ct;
	TCHAR *head;

	head = buf;
	for (;;) {
		ch = getWChar(fp);
		if (ch == ';') {
			for (;;) {
				ch = getWChar(fp);
				if (ch == -1) { buf[0] = '\0'; return TRUE; }
				if (ch == 0x0d || ch == 0x0a) break;
			}
		}
		else {
			if (ch == -1) { buf[0] = '\0'; return TRUE; }
			if (ch == ')') {
				MessageBox(hwnd,TEXT(")܂"),TEXT("G["),MB_OK);
				return FALSE;
			}
			if (ch == '(') break;
		}
	}
	ct = 1;
	if (buf - head >= BUFLEN - 2) {
		MessageBox(hwnd,TEXT("S܂B֐ɕĉB"),TEXT("G["),MB_OK);
		return FALSE;
	}
	*buf++ = (TCHAR)ch;
	for (;;) {
		ch = getWChar(fp);
		if (ch == ';') {
			for (;;) {
				ch = getWChar(fp);
				if (ch == -1) {
					MessageBox(hwnd,TEXT(")܂"),TEXT("G["),MB_OK);
					return FALSE;
				}
				if (ch == 0x0d || ch == 0x0a) break;
			}
		}
		else {
			if (ch == -1) {
				MessageBox(hwnd,TEXT(")܂"),TEXT("G["),MB_OK);
				return FALSE;
			}
            if (ch == 0x0d || ch == 0x0a) {
            	if (buf - head >= BUFLEN - 2) {
		            MessageBox(hwnd,TEXT("S܂B֐ɕĉB"),TEXT("G["),MB_OK);
		            return FALSE;
	            }
				*buf++ = ' ';
			}
			else {
				*buf = (TCHAR)ch;
				if (sizeof(TCHAR) == 1 && isKanji(buf)) {
					ch = getWChar(fp);
					if (ch == -1) {
						MessageBox(hwnd,TEXT("t@CĂ܂"),TEXT("G["),MB_OK);
						return FALSE;
					}
            	    if (buf - head >= BUFLEN - 2) {
		                MessageBox(hwnd,TEXT("S܂B֐ɕĉB"),TEXT("G["),MB_OK);
		                return FALSE;
	                }
					buf++;
					*buf = (TCHAR)ch;
				}
            	if (buf - head >= BUFLEN - 2) {
		            MessageBox(hwnd,TEXT("S܂B֐ɕĉB"),TEXT("G["),MB_OK);
		            return FALSE;
	            }
                buf++;
				if (ch == '(') ct++;
				else if (ch == ')') {
					ct--;
					if (ct == 0) {
						*buf = '\0';
						return TRUE;
					}
				}
			}
		}
	}
}

CELL *fd(CELL *p)
{
	float len;
	POINT pnt;

	if (p == NULL) return NULL;
	if (p->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	len = ((AFLOAT *)(p->car))->f;
#else
	len = *(float *)(p->car);
#endif
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
	penX = (float)(penX + len * cos(-2.0 * PI * penAngle / 360.0));
	penY = (float)(penY + len * sin(-2.0 * PI * penAngle / 360.0));
	if (penDown) {
		LineTo(ghdc,(int)(penX + centerX),(int)(penY + centerY));
		LineTo(memdc,(int)(penX + centerX),(int)(penY + centerY));
	}
	else {
		MoveToEx(ghdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
		MoveToEx(memdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
	}
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
    return p;
}

CELL *lt(CELL *p)
{
	if (p == NULL) return NULL;
	if (p->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
#if GC
	penAngle = TrueAnglePlus(penAngle + (((AFLOAT *)(p->car))->f));
#else
    penAngle = TrueAnglePlus(penAngle + *(float *)(p->car));
#endif
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
	return p;
}

float TrueAnglePlus(float f)
{
	float v = 360.0;

	if (f >= 360.0) f = fmod(f,v);
	if (f >= 180.0) f -= 360.0;
	/* sincos̈-180xȏ180xł */
	return f;
}

CELL *rt(CELL *p)
{
	if (p == NULL) return NULL;
	if (p->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
#if GC
	penAngle = TrueAngleMinus(penAngle - (((AFLOAT *)(p->car))->f));
#else
    penAngle = TrueAngleMinus(penAngle - *(float *)(p->car));
#endif
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
	return p;
}

float TrueAngleMinus(float f)
{
	float v = 360.0;

	if (f < 0.0) f = (float)(360.0 + fmod(f,v));
	if (f < -180.0) f += 360.0;
	return f;
}

CELL *bk(CELL *p)
{
	float len;
	POINT pnt;

	if (p == NULL) return NULL;
	if (p->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	len = ((AFLOAT *)(p->car))->f;
#else
	len = *(float *)(p->car);
#endif
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
	penX = (float)(penX - len * cos(-2.0 * PI * penAngle / 360.0));
	penY = (float)(penY - len * sin(-2.0 * PI * penAngle / 360.0));
	if (penDown) {
		LineTo(ghdc,(int)(penX + centerX),(int)(penY + centerY));
		LineTo(memdc,(int)(penX + centerX),(int)(penY + centerY));
	}
	else {
		MoveToEx(ghdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
		MoveToEx(memdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
	}
	if (turtleShowing) {
		XorTurtle(ghdc);
	}
    return p;
}

void XorTurtle(HDC hdc)
{
	float x1,y1,x2,y2,x3,y3;
	float len1 = 20.0,len2 = 14.0;
	float an2,an3;
	POINT pnt;
    HPEN hOldPen1,hOldPen2;
	int prev1,prev2;

	hOldPen1 = (HPEN)SelectObject(hdc,hPen);
	hOldPen2 = (HPEN)SelectObject(memdc,hPen);
	prev1 = SetROP2(hdc,R2_XORPEN);
	prev2 = SetROP2(memdc,R2_XORPEN);
	x1 = (float)(penX + len1 * cos(-2.0 * PI * penAngle / 360.0));
	y1 = (float)(penY + len1 * sin(-2.0 * PI * penAngle / 360.0));
	an2 = TrueAnglePlus((float)(penAngle + 135.0));
	an3 = TrueAngleMinus((float)(penAngle - 135.0));
	x2 = (float)(x1 + len2 * cos(-2.0 * PI * an2 / 360.0));
	y2 = (float)(y1 + len2 * sin(-2.0 * PI * an2 / 360.0));
	x3 = (float)(x1 + len2 * cos(-2.0 * PI * an3 / 360.0));
	y3 = (float)(y1 + len2 * sin(-2.0 * PI * an3 / 360.0));
	MoveToEx(hdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
	LineTo(hdc,(int)(x1 + centerX),(int)(y1 + centerY));
	LineTo(hdc,(int)(x2 + centerX),(int)(y2 + centerY));
	LineTo(hdc,(int)(x3 + centerX),(int)(y3 + centerY));
	LineTo(hdc,(int)(x1 + centerX),(int)(y1 + centerY));
	MoveToEx(hdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
	MoveToEx(memdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
	LineTo(memdc,(int)(x1 + centerX),(int)(y1 + centerY));
	LineTo(memdc,(int)(x2 + centerX),(int)(y2 + centerY));
	LineTo(memdc,(int)(x3 + centerX),(int)(y3 + centerY));
	LineTo(memdc,(int)(x1 + centerX),(int)(y1 + centerY));
	MoveToEx(memdc,(int)(penX + centerX),(int)(penY + centerY),&pnt);
//	SetROP2(hdc,R2_COPYPEN);
//	SetROP2(memdc,R2_COPYPEN);
	SetROP2(hdc,prev1);
	SetROP2(memdc,prev2);
	SelectObject(hdc,hOldPen1);
	SelectObject(memdc,hOldPen2);
}

CELL *setpos(CELL *x,CELL *y)
{
	float xd,yd;
	POINT pnt;

	if (x->attr != 'n' || y->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if (turtleShowing) {
        XorTurtle(ghdc);
	}
#if GC
	xd = ((AFLOAT *)(x->car))->f;
    yd = ((AFLOAT *)(y->car))->f;
#else
	xd = *(float *)(x->car);
	yd = *(float *)(y->car);
#endif
	if (penDown) {
		LineTo(ghdc,(int)(xd + centerX),(int)(yd + centerY));
		LineTo(memdc,(int)(xd + centerX),(int)(yd + centerY));
	}
	else {
		MoveToEx(ghdc,(int)(xd + centerX),(int)(yd + centerY),&pnt);
		MoveToEx(memdc,(int)(xd + centerX),(int)(yd + centerY),&pnt);
	}
	penX = xd;
	penY = yd;
	if (turtleShowing) {
	    XorTurtle(ghdc);
	}
	return TCell;
}

CELL *trandom(CELL *e)
{
	CELL *p;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	float v;

	if (e->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	v = (float)rand();
	v /= (float)RAND_MAX;
#if GC
	if (((AFLOAT *)(e->car))->f < 0.0) {
#else
	if (*(float *)(e->car) < 0.0) {
#endif
		MessageBox(hwnd,TEXT("ł"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	v *= ((AFLOAT *)(e->car))->f;
#else
	v *= *(float *)(e->car);
#endif
	v = (float)(int)v;
	if (!(p = getCell())) return NULL;
	if (!(f = getNumber(v))) return NULL;
	p->attr = 'n';
	p->car = (CELL *)f;
	return p;
}

CELL *tsqrt(CELL *e)
{
	CELL *p;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	float v;

	if (e->attr != 'n') {
		MessageBox(hwnd,TEXT("lł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	if (((AFLOAT *)(e->car))->f < 0.0) {
#else
	if (*(float *)(e->car) < 0.0) {
#endif
		MessageBox(hwnd,TEXT("ł"),TEXT("G["),MB_OK);
		return NULL;
	}
#if GC
	v = sqrt(((AFLOAT *)(e->car))->f);
#else
	v = sqrt(*(float *)(e->car));
#endif
	if (!(p = getCell())) return NULL;
	if (!(f = getNumber(v))) return NULL;
	p->attr = 'n';
	p->car = (CELL *)f;
	return p;
}

CELL *xwidth(void)
{
	CELL *p;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	float v;
	RECT rc;

	GetClientRect(hwnd,&rc);
	v = (float)(rc.right - rc.left);
	if (!(p = getCell())) return NULL;
	if (!(f = getNumber(v))) return NULL;
	p->attr = 'n';
	p->car = (CELL *)f;
	return p;
}

CELL *ywidth(void)
{
	CELL *p;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	float v;
	RECT rc;

	GetClientRect(hwnd,&rc);
	v = (float)(rc.bottom - rc.top);
	if (!(p = getCell())) return NULL;
	if (!(f = getNumber(v))) return NULL;
	p->attr = 'n';
	p->car = (CELL *)f;
	return p;
}

CELL *xcenter(void)
{
	CELL *p;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	float v;

	v = centerX;
	if (!(p = getCell())) return NULL;
	if (!(f = getNumber(v))) return NULL;
	p->attr = 'n';
	p->car = (CELL *)f;
	return p;
}

CELL *ycenter(void)
{
	CELL *p;
#if GC
	AFLOAT *f;
#else
	float *f;
#endif
	float v;

	v = centerY;
	if (!(p = getCell())) return NULL;
	if (!(f = getNumber(v))) return NULL;
	p->attr = 'n';
	p->car = (CELL *)f;
	return p;
}

CELL *tcs(void)
{
	static HBRUSH hbrush;

//	if (turtleShowing) XorTurtle(ghdc);
	SelectObject(ghdc,hbit);
	hbrush = (HBRUSH)GetStockObject(WHITE_BRUSH);
	SelectObject(ghdc,hbrush);
	PatBlt(ghdc,0,0,maxX,maxY,PATCOPY);
	SelectObject(memdc,hbit);
	hbrush = (HBRUSH)GetStockObject(WHITE_BRUSH);
	SelectObject(memdc,hbrush);
	PatBlt(memdc,0,0,maxX,maxY,PATCOPY);
	penX = penY = 0.0;
    penAngle = 90.0;
	if (turtleShowing) XorTurtle(ghdc);
//	InvalidateRect(hwnd,NULL,TRUE);
	return TCell;
}

CELL *setf(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *key,*ht,*cr,*p,*q,*pair;

	x = x->car;
	y = y->car;
	if (!(y = eval(y,loc,locn))) return NULL;
	if ((x->car)->attr != 's') {
		MessageBox(hwnd,TEXT("setf:Ԉ\Lł"),TEXT("G["),MB_OK);
		return NULL;
	}
	if (!lstrcmp((TCHAR *)((x->car)->car),TEXT("car")) ||
		!lstrcmp((TCHAR *)((x->car)->car),TEXT("first")) ) {
			if ((x->cdr)->attr != 'l') {
				MessageBox(hwnd,TEXT("@ԈĂ܂"),TEXT("G["),MB_OK);
				return NULL;
			}
			if (!(x = eval((x->cdr)->car,loc,locn))) return NULL;
			if (x->attr != 'l') { MessageBox(hwnd,TEXT("Z邱Ƃ͂ł܂"),TEXT("G["),MB_OK); return NULL; }
			x->car = y;
			return y;
	}
	if (!lstrcmp((TCHAR *)((x->car)->car),TEXT("cdr")) ||
		!lstrcmp((TCHAR *)((x->car)->car),TEXT("rest")) ) {
			if ((x->cdr)->attr != 'l') {
				MessageBox(hwnd,TEXT("@ԈĂ܂"),TEXT("G["),MB_OK);
				return NULL;
			}
			if (!(x = eval((x->cdr)->car,loc,locn))) return NULL;
			if (x->attr != 'l') { MessageBox(hwnd,TEXT("Z邱Ƃ͂ł܂"),TEXT("G["),MB_OK); return NULL; }
			x->cdr = y;
			return y;
	}
	if (!lstrcmp((TCHAR *)((x->car)->car),TEXT("gethash"))) {
		if ((x->cdr)->attr != 'l') goto setferror;
		if (!(key = eval((x->cdr)->car,loc,locn))) return NULL;
		if (((x->cdr)->cdr)->attr != 'l') goto setferror;
		if (!(ht = eval(((x->cdr)->cdr)->car,loc,locn))) return NULL;
		if (ht->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
		if ((ht->car)->attr != 's') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
		if (lstrcmp((TCHAR *)((ht->car)->car),TEXT("#hash-table"))) {
			MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK);
			return NULL;
		}
		if ((ht->cdr)->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
        if (!(pair = tassoc(key,ht->cdr->cdr,FALSE))) return NULL;
        if (pair != NILCell) {
			pair->cdr = y;
			return y;
		}
		cr = (ht->cdr)->cdr;
		if (!(p = getCell())) return NULL;
		p->attr = 'l';
		p->car = key;
		p->cdr = y;
		if (!(q = getCell())) return NULL;
		q->attr = 'l';
		q->car = p;
		q->cdr = cr;
		(ht->cdr)->cdr = q;
		return y;
	}
setferror:
	MessageBox(hwnd,TEXT("setf:Ԉ\Lł"),TEXT("G["),MB_OK);
	return NULL;
}

CELL *MakeHashTable(void)
{
	TCHAR *s;
	CELL *p,*q,*r;

	if (!(q = getCell())) return NULL;
	q->attr = 'l';
	if (!(s = getString(TEXT("eq")))) return NULL;
	if (!(p = getCell())) return NULL;
	p->attr = 's';
	p->car = (CELL *)s;
	q->car = p;
	q->cdr = NILCell;
	if (!(r = getCell())) return NULL;
	r->attr = 'l';
	if (!(s = getString(TEXT("#hash-table")))) return NULL;
	if (!(p = getCell())) return NULL;
	p->attr = 's';
	p->car = (CELL *)s;
	r->car = p;
	r->cdr = q;
	return r;
}

BOOL teql(CELL *p,CELL *q,BOOL sw)
{
	if (!sw) { // sw == FALSE
		if (p->attr == 's' && q->attr == 's') {
			if (!lstrcmp((TCHAR *)(p->car),(TCHAR *)(q->car))) return TRUE;
			else return FALSE;
		}
		else if (p->attr == 'n' && q->attr == 'n') {
#if GC
			if (((AFLOAT *)(p->car))->f == ((AFLOAT *)(q->car))->f) return TRUE;
#else
			if (*(float *)(p->car) == *(float *)(q->car)) return TRUE;
#endif
			else return FALSE;
		}
		else return FALSE;
	}
    return FALSE;
}

CELL *tassoc(CELL *x,CELL *y,BOOL sw)
{
	if (y->attr == 's' && !lstrcmp((TCHAR *)(y->car),TEXT("NIL"))) return NILCell;
	if (y->attr != 'l') { MessageBox(hwnd,TEXT("AzXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if ((y->car)->attr != 'l') { MessageBox(hwnd,TEXT("AzXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (teql(x,(y->car)->car,sw)) return y->car;
	return tassoc(x,y->cdr,sw);
}

CELL *gethash(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *pair;

	if (!(x = eval(x->car,loc,locn))) return NULL;
	if (!(y = eval(y->car,loc,locn))) return NULL;
	if (y->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if ((y->car)->attr != 's') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (lstrcmp((TCHAR *)((y->car)->car),TEXT("#hash-table"))) {
		MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if ((y->cdr)->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (!(pair = tassoc(x,(y->cdr)->cdr,FALSE))) return NULL;
	if (pair == NILCell) return pair;
	if (pair->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uĂ܂"),TEXT("G["),MB_OK); return NULL; }
	return pair->cdr;
}

CELL *remhash(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *pair,*b,*a;

	if (!(x = eval(x->car,loc,locn))) return NULL;
	if (!(y = eval(y->car,loc,locn))) return NULL;
	if (y->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if ((y->car)->attr != 's') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (lstrcmp((TCHAR *)((y->car)->car),TEXT("#hash-table"))) {
		MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK);
		return NULL;
	}
	if ((y->cdr)->attr != 'l') { MessageBox(hwnd,TEXT("nbVe[uł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (!(pair = tassoc(x,(y->cdr)->cdr,FALSE))) return NULL;
	if (pair == NILCell) return pair;
	if (!(b = BeforeAssoc(x,(y->cdr)->cdr,FALSE,y->cdr))) return NULL;
	if (!(a = AfterAssoc(x,(y->cdr)->cdr,FALSE))) return NULL;
	b->cdr = a;
	return TCell;
}

CELL *BeforeAssoc(CELL *x,CELL *y,BOOL sw,CELL *tar)
{
	if (y->attr == 's' && !lstrcmp((TCHAR *)(y->car),TEXT("NIL"))) return NILCell;
	if (y->attr != 'l') { MessageBox(hwnd,TEXT("AzXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if ((y->car)->attr != 'l') { MessageBox(hwnd,TEXT("AzXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (teql(x,(y->car)->car,sw)) return tar;
	return BeforeAssoc(x,y->cdr,sw,y);
}

CELL *AfterAssoc(CELL *x,CELL *y,BOOL sw)
{
	if (y->attr == 's' && !lstrcmp((TCHAR *)(y->car),TEXT("NIL"))) return NILCell;
	if (y->attr != 'l') { MessageBox(hwnd,TEXT("AzXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if ((y->car)->attr != 'l') { MessageBox(hwnd,TEXT("AzXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	if (teql(x,(y->car)->car,sw)) return y->cdr;
	return AfterAssoc(x,y->cdr,sw);
}

CELL *funcall(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *z;
	long len;
	SYMVAL *temploc;
	CELL *p;

	if (!(x = eval(x->car,loc,locn))) return NULL;
	if (x->attr == 's') {
        if (!(z = getCell())) return NULL;
		z->attr = 'l';
		z->car = x;
		z->cdr = y;
		return eval(z,loc,locn);
	}
	else if (x->attr == 'l' && (x->car)->attr == 's' && !lstrcmp((TCHAR *)((x->car)->car),TEXT("lambda"))) {
		if ((x->cdr)->attr != 'l') { MessageBox(hwnd,TEXT("@G["),TEXT("G["),MB_OK); return NULL; }
		len = tlength((x->cdr)->car);
		temploc = (SYMVAL *)calloc(len,sizeof(SYMVAL));
		if (temploc == NULL) {
			MessageBox(hwnd,TEXT("[Jϐ̈̊mۂɎs܂"),TEXT("G["),MB_OK);
			return NULL;
		}
		if (!initTemploc(temploc,len,(x->cdr)->car,y,loc,locn)) {
			MessageBox(hwnd,TEXT("܂"),TEXT("G["),MB_OK);
			free(temploc);
			return NULL;
		}
#if GC
			    IncCellStack(NULL);
//			    *curNumberStack++ = NULL;
			    if (IncLocStack(NULL,1) == -1) {
				    free(temploc);
				    return NULL;
			    }
			    if (IncLocStack(temploc,len) == -1) {
				    free(temploc);
				    return NULL;
			    }
#endif
		p = tprogn((x->cdr)->cdr,temploc,len);
#if GC
				while (*(--curLocStack) != NULL);
			    while (*(--curCellStack) != NULL);
//			    while (*(--curNumberStack) != NULL);
//				if (p->attr != 's') IncCellStack(p);    // Add on 2013.10.23
#endif
		free(temploc);
		return p;
	}
	MessageBox(hwnd,TEXT("funcalľĂяoԈĂ܂"),TEXT("G["),MB_OK);
	return NULL;
}

CELL *apply(CELL *x,CELL *y,SYMVAL *loc,long locn)
{
	CELL *tp,*z,*p,*r,*q,*d,*e;
	TCHAR *s;
	long len;
	SYMVAL *temploc;

	if (!(x = eval(x->car,loc,locn))) return NULL;
	if (y->attr == 's' || y->attr == 'n') y = NILCell;
	else {
		if (!(y = eval(y->car,loc,locn))) return NULL;
		if (y->attr != 'l') { MessageBox(hwnd,TEXT("QXgł͂܂"),TEXT("G["),MB_OK); return NULL; }
	}
	if (!(s = getString(TEXT("quote")))) return NULL;
	if (!(p = getCell())) return NULL;
	p->attr = 's';
	p->car = (CELL *)s;
	if (!(z = getCell())) return NULL;
	tp = z;
	while (y->attr == 'l') {
		if (!(e = getCell())) return NULL;
		z->attr = 'l'; // z = ()
		e->attr = 'l'; // e = ()
		e->car = p;    // e = (quote)
		z->car = e;    // z = ((quote))
		if (!(q = getCell())) return NULL;
		e->cdr = q;    // z = ((quote ()))
		q->attr = 'l'; // z = ((quote ()))
		q->car = y->car; // z = ((quote a))
		q->cdr = NILCell;
        if (!(d = getCell())) return NULL;
		z->cdr = d;
		z = d;
		y = y->cdr;
	}
	z = NILCell;
	if (x->attr == 's') {
		if (!(r = getCell())) return NULL;
		r->attr = 'l';
		r->car = x;
		r->cdr = tp;
		return eval(r,loc,locn);
	}
	else if (x->attr == 'l' && (x->car)->attr == 's' && !lstrcmp((TCHAR *)((x->car)->car),TEXT("lambda"))) {
		if ((x->cdr)->attr != 'l') { MessageBox(hwnd,TEXT("@G["),TEXT("G["),MB_OK); return NULL; }
		len = tlength((x->cdr)->car);
		temploc = (SYMVAL *)calloc(len,sizeof(SYMVAL));
		if (temploc == NULL) {
			MessageBox(hwnd,TEXT("[Jϐ̈̊mۂɎs܂"),TEXT("G["),MB_OK);
			return NULL;
		}
		if (!initTemploc(temploc,len,(x->cdr)->car,tp,loc,locn)) {
			MessageBox(hwnd,TEXT("܂"),TEXT("G["),MB_OK);
			free(temploc);
			return NULL;
		}
#if GC
			    IncCellStack(NULL);
//			    *curNumberStack++ = NULL;
			    if (IncLocStack(NULL,1) == -1) {
				    free(temploc);
				    return NULL;
			    }
			    if (IncLocStack(temploc,len) == -1) {
				    free(temploc);
				    return NULL;
			    }
#endif
		p = tprogn((x->cdr)->cdr,temploc,len);
#if GC
				while (*(--curLocStack) != NULL);
			    while (*(--curCellStack) != NULL);
//			    while (*(--curNumberStack) != NULL);
//				if (p->attr != 's') IncCellStack(p);    // Add on 2013.10.23
#endif
		free(temploc);
		return p;
	}
	MessageBox(hwnd,TEXT("apply̌ĂяoԈĂ܂"),TEXT("G["),MB_OK);
	return NULL;
}

BOOL MakeQuoteText(TCHAR *b,int len)
{
	int plen;
	TCHAR *q;

	plen = lstrlen(b);
	if (plen >= len) { MessageBox(hwnd,TEXT("r܂"),TEXT("G["),MB_OK); return FALSE; }
	while (*b != '\0') {
		if (*b == '\'') {
			*b++ = '('; plen += 6; if (plen >= len) { MessageBox(hwnd,TEXT("r܂"),TEXT("G["),MB_OK); return FALSE; }
			slide(b,6); *b++ = 'q'; *b++ = 'u'; *b++ = 'o'; *b++ = 't'; *b++ = 'e'; *b = ' ';
			q = taiou(b);
			plen++; if (plen >= len) { MessageBox(hwnd,TEXT("r܂"),TEXT("G["),MB_OK); return FALSE; }
			slide(q,1);
			*q = ')';
		}
		else b++;
	}
	return TRUE;
}

void slide(TCHAR *b,int len)
{
	TCHAR *q;

	q = b;
	while (*q != '\0') q++;
	while (q != b) {
		*(q + len) = *q;
		q--;
	}
	*(q + len) = *q;
}

TCHAR *taiou(TCHAR *b)
{
	int ct;

	b = SkipSpc(b);
	if (*b != '(') {
		while (*b != '\0' && *b != ')' && *b != ' ' && *b != '(') b++;
		return b;
	}
	else {
		ct = 0;
		for (;;) {
			if (*b == '(') ct++;
			else if (*b == ')') {
				ct--;
				if (ct == 0) return b + 1;
			}
			b++;
		}
	}
}

#if USE_PRINTER
/*
void turPrintOut(void)
{
	PRINTDLG pd;
    DOCINFO di;

	memset(&pd,0,sizeof(PRINTDLG));
	pd.lStructSize = sizeof(PRINTDLG);
	pd.hwndOwner = hwnd;
	pd.hDevMode = NULL;
	pd.hDevNames = NULL;
	pd.Flags = PD_USEDEVMODECOPIESANDCOLLATE | PD_RETURNDC | PD_NOPAGENUMS | PD_NOSELECTION | PD_HIDEPRINTTOFILE;
	pd.nMinPage = 1;
	pd.nMaxPage = 1;
	pd.nFromPage = 1;
	pd.nToPage = 1;
	pd.nCopies = 1;

	if (PrintDlg(&pd) == 0) return;

	memset(&di,0,sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = TEXT("printout");

	StartDoc(pd.hDC,&di);
	StartPage(pd.hDC);
	TextOut(pd.hDC,10,10,TEXT("Hello"),lstrlen(TEXT("Hello")));
    MoveToEx(pd.hDC,0,0,NULL);
	LineTo(pd.hDC,(int)centerX,(int)centerY);
	Ellipse(pd.hDC,0,0,1000,1000);
	EndPage(pd.hDC);
	EndDoc(pd.hDC);
	DeleteDC(pd.hDC);
}
*/
void turPrintOut(void)
{
	PRINTDLG pd;
    DOCINFO di;

	memset(&pd,0,sizeof(PRINTDLG));
	pd.lStructSize = sizeof(PRINTDLG);
	pd.hwndOwner = hwnd;
	pd.hDevMode = NULL;
	pd.hDevNames = NULL;
	pd.Flags = PD_USEDEVMODECOPIESANDCOLLATE | PD_RETURNDC | PD_NOPAGENUMS | PD_NOSELECTION | PD_HIDEPRINTTOFILE;
	pd.nMinPage = 1;
	pd.nMaxPage = 1;
	pd.nFromPage = 1;
	pd.nToPage = 1;
	pd.nCopies = 1;

	if (PrintDlg(&pd) == 0) {
        LineCircle = FALSE;
		return;
	}

	printerCenterX = (float)((double)(GetDeviceCaps(pd.hDC,PHYSICALWIDTH) - 2 * GetDeviceCaps(pd.hDC,PHYSICALOFFSETX)) / 2.0);
	printerCenterY = (float)((double)(GetDeviceCaps(pd.hDC,PHYSICALHEIGHT) - 2 * GetDeviceCaps(pd.hDC,PHYSICALOFFSETY)) / 2.0);

	memset(&di,0,sizeof(DOCINFO));
	di.cbSize = sizeof(DOCINFO);
	di.lpszDocName = TEXT("printout");

	StartDoc(pd.hDC,&di);
	StartPage(pd.hDC);
	LineCircle = DrawLineAndCicrle(pd.hDC);
	EndPage(pd.hDC);
	EndDoc(pd.hDC);
	DeleteDC(pd.hDC);
}

void turWrite(void)
{
	FILE *fp1,*fp2;
	TCHAR fname1[257],fname2[257];

    if (filenameCell->attr != 's') {
        MessageBox(hwnd,TEXT("t@CԈĂ܂B"),TEXT("G["),MB_OK);
		LineCircle = FALSE;
		return;
	}
	lstrcpy(fname1,(TCHAR *)(filenameCell->car));
	lstrcpy(fname2,fname1);
	lstrcat(fname1,TEXT(".lin"));
	lstrcat(fname2,TEXT(".ar"));
	_wfopen_s(&fp1,fname1,TEXT("w"));
	_wfopen_s(&fp2,fname2,TEXT("w"));
    LineCircle = SaveLineAndCircle(fp1,fp2);
    fclose(fp1);
	fclose(fp2);
}

void turRead(void)
{
	FILE *fp1,*fp2;
	TCHAR fname1[257],fname2[257];
	CELL *p1,*p2;

	returnCell = NILCell;
	if (filenameCell->attr != 's') {
        MessageBox(hwnd,TEXT("t@CԈĂ܂B"),TEXT("G["),MB_OK);
		return;
	}
	lstrcpy(fname1,(TCHAR *)(filenameCell->car));
	lstrcpy(fname2,fname1);
	lstrcat(fname1,TEXT(".lin"));
	lstrcat(fname2,TEXT(".ar"));
	_wfopen_s(&fp1,fname1,TEXT("r"));
	if (fp1 == NULL) {
		MessageBox(hwnd,TEXT("t@CJƂł܂"),TEXT("G["),MB_OK);
        returnCell = NULL;
		return;
	}
	_wfopen_s(&fp2,fname2,TEXT("r"));
	if (fp2 == NULL) {
		MessageBox(hwnd,TEXT("t@CJƂł܂"),TEXT("G["),MB_OK);
        returnCell = NULL;
		return;
	}
	if ((p1 = getCell()) == NULL) {
		returnCell = NULL;
		return;
	}
	if ((p2 = getCell()) == NULL) {
		returnCell = NULL;
		return;
	}
	if ((p1->car = getLineLc(fp1)) == NULL) {
		returnCell = NULL;
		return;
	}
    p1->cdr = p2;
	if ((p2->car = getCircleLc(fp2)) == NULL) {
		returnCell = NULL;
		return;
	}
	p2->cdr = NILCell;
	p1->attr = 'l';
	p2->attr = 'l';
	returnCell = p1;
	fclose(fp1);
	fclose(fp2);
}

CELL *getLineLc(FILE *fp)
{
	float x1,y1,x2,y2;
	CELL *p1,*p2,*p3,*p4,*p;
	CELL *n1,*n2,*n3,*n4;
	CELL *q;

	q = NILCell;
	while (fscanf_s(fp,"%f %f %f %f",&x1,&y1,&x2,&y2) != EOF) {
		if ((p4 = getCell()) == NULL) return NULL;
        p4->attr = 'l';
		p4->cdr = NILCell;
		if ((n4 = getCell()) == NULL) return NULL;
		n4->attr = 'n';
		if ((n4->car = (CELL *)getNumber(y2)) == NULL) return NULL;
		p4->car = n4;

		if ((p3 = getCell()) == NULL) return NULL;
		p3->attr = 'l';
		p3->cdr = p4;
		if ((n3 = getCell()) == NULL) return NULL;
		n3->attr = 'n';
		if ((n3->car = (CELL *)getNumber(x2)) == NULL) return NULL;
		p3->car = n3;

		if ((p2 = getCell()) == NULL) return NULL;
		p2->attr = 'l';
		p2->cdr = p3;
		if ((n2 = getCell()) == NULL) return NULL;
		n2->attr = 'n';
		if ((n2->car = (CELL *)getNumber(y1)) == NULL) return NULL;
		p2->car = n2;

		if ((p1 = getCell()) == NULL) return NULL;
		p1->attr = 'l';
		p1->cdr = p2;
		if ((n1 = getCell()) == NULL) return NULL;
		n1->attr = 'n';
		if ((n1->car = (CELL *)getNumber(x1)) == NULL) return NULL;
		p1->car = n1;

		if ((p = getCell()) == NULL) return NULL;
		p->attr = 'l';
		p->car = p1;
		p->cdr = q;
		q = p;
	}
	return q;
}

CELL *getCircleLc(FILE *fp)
{
	float x1,y1,x2,y2,x3,y3,x4,y4;
	CELL *p1,*p2,*p3,*p4,*p;
	CELL *n1,*n2,*n3,*n4;
	CELL *q;
	CELL *p5,*p6,*p7,*p8,*n5,*n6,*n7,*n8;

	q = NILCell;
	while (fscanf_s(fp,"%f %f %f %f %f %f %f %f",&x1,&y1,&x2,&y2,&x3,&y3,&x4,&y4) != EOF) {
		if ((p8 = getCell()) == NULL) return NULL;
        p8->attr = 'l';
		p8->cdr = NILCell;
		if ((n8 = getCell()) == NULL) return NULL;
		n8->attr = 'n';
		if ((n8->car = (CELL *)getNumber(y4)) == NULL) return NULL;
		p8->car = n8;

		if ((p7 = getCell()) == NULL) return NULL;
        p7->attr = 'l';
		p7->cdr = p8;
		if ((n7 = getCell()) == NULL) return NULL;
		n7->attr = 'n';
		if ((n7->car = (CELL *)getNumber(x4)) == NULL) return NULL;
		p7->car = n7;

		if ((p6 = getCell()) == NULL) return NULL;
        p6->attr = 'l';
		p6->cdr = p7;
		if ((n6 = getCell()) == NULL) return NULL;
		n6->attr = 'n';
		if ((n6->car = (CELL *)getNumber(y3)) == NULL) return NULL;
		p6->car = n6;

		if ((p5 = getCell()) == NULL) return NULL;
        p5->attr = 'l';
		p5->cdr = p6;
		if ((n5 = getCell()) == NULL) return NULL;
		n5->attr = 'n';
		if ((n5->car = (CELL *)getNumber(x3)) == NULL) return NULL;
		p5->car = n5;

		if ((p4 = getCell()) == NULL) return NULL;
        p4->attr = 'l';
		p4->cdr = p5;
		if ((n4 = getCell()) == NULL) return NULL;
		n4->attr = 'n';
		if ((n4->car = (CELL *)getNumber(y2)) == NULL) return NULL;
		p4->car = n4;

		if ((p3 = getCell()) == NULL) return NULL;
		p3->attr = 'l';
		p3->cdr = p4;
		if ((n3 = getCell()) == NULL) return NULL;
		n3->attr = 'n';
		if ((n3->car = (CELL *)getNumber(x2)) == NULL) return NULL;
		p3->car = n3;

		if ((p2 = getCell()) == NULL) return NULL;
		p2->attr = 'l';
		p2->cdr = p3;
		if ((n2 = getCell()) == NULL) return NULL;
		n2->attr = 'n';
		if ((n2->car = (CELL *)getNumber(y1)) == NULL) return NULL;
		p2->car = n2;

		if ((p1 = getCell()) == NULL) return NULL;
		p1->attr = 'l';
		p1->cdr = p2;
		if ((n1 = getCell()) == NULL) return NULL;
		n1->attr = 'n';
		if ((n1->car = (CELL *)getNumber(x1)) == NULL) return NULL;
		p1->car = n1;

		if ((p = getCell()) == NULL) return NULL;
		p->attr = 'l';
		p->car = p1;
		p->cdr = q;
		q = p;
	}
	return q;
}

BOOL SaveLineAndCircle(FILE *fp1,FILE *fp2)
{
	BOOL Result = TRUE,r;
	CELL *p;
	float left,top,right,bottom;
//	char buf[40];

	p = linesCell;
	for (;;) {
		if (p->attr == 's' || p->attr == 'n') break;
		r = GetLineCorFloat(p->car,&left,&top,&right,&bottom);
		if (r == FALSE) Result = FALSE;
		else {
            fprintf(fp1,"%f %f %f %f ",left,top,right,bottom);
/*            sprintf_s(buf,"%f",left);
		    fputs(buf,fp1);
            sprintf_s(buf,"%f",top);
		    fputs(buf,fp1);
            sprintf_s(buf,"%f",right);
		    fputs(buf,fp1);
            sprintf_s(buf,"%f",bottom);
		    fputs(buf,fp1);
*/		}
		p = p->cdr;
	}
	p = circlesCell;
	for (;;) {
		if (p->attr == 's' || p->attr == 'n') break;
		r = SaveOneArc(fp2,p->car);
		if (r == FALSE) Result = FALSE;
		p = p->cdr;
	}
	return Result;
}

BOOL DrawLineAndCicrle(HDC hdc)
{
	BOOL Result = TRUE,r;
	CELL *p;
	int left,top,right,bottom;

	p = linesCell;
	for (;;) {
		if (p->attr == 's' || p->attr == 'n') break;
		r = GetLineCor(p->car,&left,&top,&right,&bottom);
		if (r == FALSE) Result = FALSE;
		else {
			MoveToEx(hdc,left,top,NULL);
			LineTo(hdc,right,bottom);
		}
		p = p->cdr;
	}
	p = circlesCell;
	for (;;) {
		if (p->attr == 's' || p->attr == 'n') break;
		r = OneArc(hdc,p->car);
		if (r == FALSE) Result = FALSE;
		p = p->cdr;
	}
	return Result;
}

BOOL OneArc(HDC hdc,CELL *p)
{
	CELL *q;
	int x1,y1,x2,y2,x3,y3,x4,y4;

	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x1 = (int)(((AFLOAT *)(q->car))->f + printerCenterX);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y1 = (int)(((AFLOAT *)(q->car))->f + printerCenterY);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x2 = (int)(((AFLOAT *)(q->car))->f + printerCenterX);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y2 = (int)(((AFLOAT *)(q->car))->f + printerCenterY);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x3 = (int)(((AFLOAT *)(q->car))->f + printerCenterX);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y3 = (int)(((AFLOAT *)(q->car))->f + printerCenterY);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x4 = (int)(((AFLOAT *)(q->car))->f + printerCenterX);
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y4 = (int)(((AFLOAT *)(q->car))->f + printerCenterY);

	Arc(hdc,x1,y1,x2,y2,x3,y3,x4,y4);

	return TRUE;
}

BOOL SaveOneArc(FILE *fp,CELL *p)
{
	CELL *q;
	float x1,y1,x2,y2,x3,y3,x4,y4;

	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x1 = ((AFLOAT *)(q->car))->f + printerCenterX;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y1 = ((AFLOAT *)(q->car))->f + printerCenterY;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x2 = ((AFLOAT *)(q->car))->f + printerCenterX;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y2 = ((AFLOAT *)(q->car))->f + printerCenterY;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x3 = ((AFLOAT *)(q->car))->f + printerCenterX;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y3 = ((AFLOAT *)(q->car))->f + printerCenterY;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	x4 = ((AFLOAT *)(q->car))->f + printerCenterX;
	p = p->cdr;
	if (p->attr != 'l') return FALSE;
	q = p->car;
	if (q->attr != 'n') return FALSE;
	y4 = ((AFLOAT *)(q->car))->f + printerCenterY;

	fprintf(fp,"%f %f %f %f %f %f %f %f ",x1,y1,x2,y2,x3,y3,x4,y4);

	return TRUE;
}

BOOL GetLineCor(CELL *p,int *left,int *top,int *right,int *bottom)
{
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*left = (int)(((AFLOAT *)((p->car)->car))->f + printerCenterX);
	p = p->cdr;
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*top = (int)(((AFLOAT *)((p->car)->car))->f + printerCenterY);
	p = p->cdr;
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*right = (int)(((AFLOAT *)((p->car)->car))->f + printerCenterX);
	p = p->cdr;
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*bottom = (int)(((AFLOAT *)((p->car)->car))->f + printerCenterY);
	return TRUE;
}

BOOL GetLineCorFloat(CELL *p,float *left,float *top,float *right,float *bottom)
{
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*left = ((AFLOAT *)((p->car)->car))->f + printerCenterX;
	p = p->cdr;
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*top = ((AFLOAT *)((p->car)->car))->f + printerCenterY;
	p = p->cdr;
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*right = ((AFLOAT *)((p->car)->car))->f + printerCenterX;
	p = p->cdr;
    if (p->attr != 'l') return FALSE;
	if ((p->car)->attr != 'n') return FALSE;
	*bottom = ((AFLOAT *)((p->car)->car))->f + printerCenterY;
	return TRUE;
}
#endif